from netCDF4 import Dataset
import wx
import os
import numpy as npy

class nc_file_cl:
    def __init__(self, path='', flnm='', wnd=None):
        self.flnm=flnm
        self.path=path
        self.ncdata=None
        
        self.wnd=wnd
        self.open_nc_file(self.path, self.flnm)
        

    def open_nc_file(self, path, flnm):
        if (self.ncdata<>None):
            self.ncdata.close()
            
        flnm=flnm.strip()
        self.flnm=flnm
        
        if (len(flnm)==0):
            wildcard = "NetCDF files (*.nc) |*.nc | All files (*.*)|*.*"
            dirname=path.strip()
            
            if (dirname==''):
                dirname=os.getcwd()
            self.path=dirname
            
            if (self.wnd==None):
                self.wnd=wx.GetActiveWindow()
        
            dlg=wx.FileDialog(self.wnd, "Choose NetCDF file Info", dirname, "", wildcard=wildcard, \
                                  style=wx.FD_OPEN | wx.CHANGE_DIR)
            dlg.SetFilterIndex(1)
            
            if (dlg.ShowModal()==wx.ID_OK):
                filename=dlg.GetFilename()
                dirname=dlg.GetDirectory()
                full_name=os.path.join(dirname, filename)
                self.flnm=filename
                self.path=dirname
                dlg.Destroy()
            else:
                dlg.Destroy()
                return False
            
        else:
            self.flnm=flnm
            self.path=path
            full_name=path+'/'+flnm
        
        self.ncdata=Dataset(full_name)
        
                
        return False
    def listvar(self, close_file=True):
        if (self.ncdata==None):
            self.open_nc_file(self.path, self.flnm)

        
        if (self.ncdata==None):
            return 0
        else:
            icnt=0
            for varname in self.ncdata.variables:
                var=self.ncdata.variables[varname]
                info_str=varname
                icnt=icnt+1
                
                try:
                    dims=var.dimensions
                    
                    print icnt, varname, dims
                    
                except:
                    print icnt, info_str
            
            if (close_file):
                self.close()
            
            return icnt
    
    def getvar(self, varname_lst, close_file=True):
        
        if (self.ncdata==None):
            self.open_nc_file(self.path, self.flnm)

        if (self.ncdata==None):
            return 0
        else:
            
            if (type(varname_lst)==type('aaa')):
                var=self.ncdata.variables[varname][:]
                return var
            
                
            else: 
                var_lst=list()
                for varname in varname_lst:
                    var=self.ncdata.variables[varname][:]
                    var_lst.append(var)
                
                if (close_file):
                    self.close()
                    
                
                return var_lst
    
    def close(self):
        if (self.ncdata==None):
            return 0
        else:
            self.ncdata.close()
            self.ncdata=None
            return 0
        
        
        
                    
    
    
