#! /geos/u23/epd7/bin/python2.7

try:
    import wx
except ImportError:
    print '*'*30+'WARNING'+'*'*30
    print 'Incorrect Python version!' 
    print 'please use ./bpchdump.py'
    print '*'*80
    exit()



import os
# os.system("export LD_RUN_PATH=$LD_RUN_PATH:./lib_ifort")
# os.system("export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:./lib_ifort")
# os.system("echo $LD_RUN_PATH")
# os.system("echo $LD_LIBRARY_PATH")
import os as os_cmd

import matplotlib
matplotlib.use('WXAgg')

from numpy import *
from pylab import *

import ESA.util.time_module as tm
import ESA.util.bpch2_rw_smp as bpch2_mod
import images
import wx.py as pysh
import wx_map_plot as wmplot

import wx_zonalmean_plot as wm_mean_plot

import field_grid as fgrd
import ESA.util.gen_plots as gpl
import ESA.util.flib
import ESA.util.otool_var_io as ovar
import ESA.util.otool_ncfile_io as ncfio
import ESA.atmosphere.compute_gc_grid as cmg
import ESA.util.gp_axis_m as gax
import ncfile_open as n4fc

            


file_idd=list()
file_idd.append(0)
print file_idd

cur_l={}
cur_d=None

test_d=300.0

FIG_MAP_ID=20
FIG_COL_ID=21
FIG_ZON_ID=22


ID_LOAD=120
ID_EXIT=110
ID_SAVEDEF=140
ID_SAVE_SETTING=150
ID_ABOUT=101
ID_SET=130
ID_SELECT_SP=180

ID_BROWSE=210
ID_BROWSE_TRACER=220
ID_BROWSE_DIAG=230
ID_BROWSE_SP=350

ID_VIEW_ZM=260
ID_VIEW_COL=290
ID_VIEW_MAP=320
ID_VIEW_OP=350

ID_CONVERT_REGRID=400


ID_ANIMATE_ZM=460
ID_ANIMATE_COL=490
ID_ANIMATE_MAP=420
ID_ANIMATE_OP=450



default_setting_file=os.path.expanduser('~')+'/.bpchwx'


class MyFileDialog_regrid(wx.Dialog):
    def __init__(self, parent, ID, title, \
                     defDir,\
                     defFlnm="", \
                     defTracer="",\
                     size=wx.DefaultSize, pos=wx.DefaultPosition, \
                     style=wx.DEFAULT_DIALOG_STYLE, useMetal=False):
        
        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.

        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)
        

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.

        self.PostCreate(pre)

        # This extra style can be set after the UI object has been created.
        if 'wxMac' in wx.PlatformInfo and useMetal:
            self.SetExtraStyle(wx.DIALOG_EX_METAL)
            
        
        # Now continue with the normal construction of the dialog
        # contents

        
        panel_w=wx.Panel(self,-1, size=(500, -1))
        vbox=wx.BoxSizer(wx.VERTICAL)
        
        panel_fl=wx.Panel(panel_w, -1)
        hbox2=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_fl, -1, "Filename:")
        flnmlabel.SetHelpText("File Name")
        hbox2.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.flnmtext = wx.TextCtrl(panel_fl, -1, "", size=(-1,30))
        self.flnmtext.SetHelpText("Set File name")
        self.flnmtext.SetValue(defDir+'/'+defFlnm)
        hbox2.Add(self.flnmtext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        panel_fl.SetSizer(hbox2)
        
        
        vbox.Add(panel_fl, 0, wx.ALL|wx.EXPAND, 1)
        
        
        panel_tr=wx.Panel(panel_w, -1)
        hbox3=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_tr, -1, "Select Tracer:")
        flnmlabel.SetHelpText("Select tracer")
        hbox3.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.tracertext = wx.TextCtrl(panel_tr, -1, "", size=(-1,30))
        self.tracertext.SetHelpText("Set tracer number")
        self.tracertext.SetValue(defTracer)
        
        hbox3.Add(self.tracertext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        panel_tr.SetSizer(hbox3)
        vbox.Add(panel_tr, 0, wx.ALL|wx.EXPAND, 1)
        
        panel_mod=wx.Panel(panel_w, -1)
        hbox4=wx.BoxSizer(wx.HORIZONTAL)
        
        self.mod3 = wx.RadioButton(panel_mod, -1, 'GEOS3', (10,-1), style=wx.RB_GROUP)
        hbox4.Add(self.mod3, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.mod4 = wx.RadioButton(panel_mod, -1, 'GEOS4', (70,-1))
        hbox4.Add(self.mod4, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        self.mod5 = wx.RadioButton(panel_mod, -1, 'GEOS5', (130,-1))
        hbox4.Add(self.mod5, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        self.mod5.SetValue(True)
        
        
        
        panel_mod.SetSizer(hbox4)


        
        vbox.Add(panel_mod, 0, wx.ALL|wx.EXPAND, 1)

        # maximum and minmum values

        panel_res=wx.Panel(panel_w, -1)
        hbox5=wx.BoxSizer(wx.HORIZONTAL)
        
        self.res4x5 = wx.RadioButton(panel_res, -1, '4x5',  style=wx.RB_GROUP)
        hbox5.Add(self.res4x5, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.res2x25 = wx.RadioButton(panel_res, -1, '2x25')
        hbox5.Add(self.res2x25, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.res1x1 = wx.RadioButton(panel_res, -1, '1x1')
        hbox5.Add(self.res1x1, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.res05x06 = wx.RadioButton(panel_res, -1, '05x06')
        hbox5.Add(self.res05x06, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)


        self.res2x25.SetValue(True)
        
        
        panel_res.SetSizer(hbox5)
        vbox.Add(panel_res, 0, wx.ALL|wx.EXPAND, 1)

        # set the convert factor and unit
        
        # set the convert factor and unit
        
        panel_unit=wx.Panel(panel_w, -1)
        hbox6=wx.BoxSizer(wx.HORIZONTAL)
                
        flnmlabel = wx.StaticText(panel_unit, -1, "Fixed V1:")
        flnmlabel.SetHelpText("Set the fixed value for tracer 1")
        hbox6.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.fix1text = wx.TextCtrl(panel_unit, -1, "", size=(-1,30))
        self.fix1text.SetHelpText("Fixed value for tracer 1")
        self.fix1text.SetValue('-999.0')
        
        hbox6.Add(self.fix1text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        

        flnmlabel = wx.StaticText(panel_unit, -1, "Fixed V-other:")
        flnmlabel.SetHelpText("Fixed values for others ")
        hbox6.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.fix2text = wx.TextCtrl(panel_unit, -1, "", size=(-1,30))
        self.fix2text.SetHelpText("Set Fixed value for others")
        self.fix2text.SetValue("-999.0")
        
        hbox6.Add(self.fix2text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        panel_unit.SetSizer(hbox6)
                
        vbox.Add(panel_unit, 0, wx.ALL|wx.EXPAND, 1)
        
        
        # sizer.Add(gs, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        line = wx.StaticLine(panel_w, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        vbox.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)
        
        btnsizer = wx.StdDialogButtonSizer()
        
        # if wx.Platform != "__WXMSW__":
        #    btn = wx.ContextHelpButton(self)
        #     btnsizer.AddButton(btn)
        
        btn = wx.Button(panel_w, wx.ID_OK)
        btn.SetHelpText("The OK button completes the dialog")
        
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(panel_w, wx.ID_CANCEL)
        btn.SetHelpText("The Cancel button cancels the dialog. (Cool, huh?)")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        
        vbox.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        vbox.Add((-1, 5))
        
        panel_w.SetSizer(vbox)
        vbox.Fit(panel_w)
        
        # self.Show()


class MyFileDialog_option(wx.Dialog):
    def __init__(self, parent, ID, title, 
                 defIX1=0, \
                 defIX2=144,\
                 defJY1=0, \
                 defJY2=91,\
                 defKZ1=0, \
                 defKZ2=47,\
                 defVmax=0.0,\
                 defVmin=0.0,\
                 defFactor=1.0,\
                 defUnit='v/v',\
                 defFigName="",\
                 defFigTitle="",\
                 size=wx.DefaultSize, pos=wx.DefaultPosition, \
                 style=wx.DEFAULT_DIALOG_STYLE, useMetal=False):
        
        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.

        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)
        

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.

        self.PostCreate(pre)

        # This extra style can be set after the UI object has been created.
        if 'wxMac' in wx.PlatformInfo and useMetal:
            self.SetExtraStyle(wx.DIALOG_EX_METAL)
            
        
        # Now continue with the normal construction of the dialog
        # contents

        
        panel_w=wx.Panel(self,-1, size=(500, -1))
        vbox=wx.BoxSizer(wx.VERTICAL)
        
        panel_ix=wx.Panel(panel_w, -1)
        hbox2=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_ix, -1, "IX1:")
        flnmlabel.SetHelpText("Start X")
        hbox2.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.ix1text = wx.TextCtrl(panel_ix, -1, "", size=(-1,30))
        self.ix1text.SetHelpText("Set Start X")
        self.ix1text.SetValue(str(defIX1))
        
        
        hbox2.Add(self.ix1text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        flnmlabel = wx.StaticText(panel_ix, -1, "IX2:")
        flnmlabel.SetHelpText("End X")
        hbox2.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.ix2text = wx.TextCtrl(panel_ix, -1, "", size=(-1,30))
        self.ix2text.SetHelpText("Set Start X")
        self.ix2text.SetValue(str(defIX2))
        
        hbox2.Add(self.ix2text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        panel_ix.SetSizer(hbox2)

        
        vbox.Add(panel_ix, 0, wx.ALL|wx.EXPAND, 1)
        
        
        panel_jy=wx.Panel(panel_w, -1)
        hbox3=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_jy, -1, "IY1:")
        flnmlabel.SetHelpText("Start Y")
        hbox3.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.jy1text = wx.TextCtrl(panel_jy, -1, "", size=(-1,30))
        self.jy1text.SetHelpText("Set Start Y")
        self.jy1text.SetValue(str(defJY1))
        
        hbox3.Add(self.jy1text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        flnmlabel = wx.StaticText(panel_jy, -1, "JY2:")
        flnmlabel.SetHelpText("End Y")
        hbox3.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.jy2text = wx.TextCtrl(panel_jy, -1, "", size=(-1,30))
        self.jy2text.SetHelpText("Set End  Y")
        self.jy2text.SetValue(str(defJY2))
        
        hbox3.Add(self.jy2text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        panel_jy.SetSizer(hbox3)

        
        vbox.Add(panel_jy, 0, wx.ALL|wx.EXPAND, 1)
        
        panel_kz=wx.Panel(panel_w, -1)
        hbox4=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_kz, -1, "KZ1:")
        flnmlabel.SetHelpText("Start Y")
        hbox4.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.kz1text = wx.TextCtrl(panel_kz, -1, "", size=(-1,30))
        self.kz1text.SetHelpText("Set Start Z")
        self.kz1text.SetValue(str(defKZ1))
        
        hbox4.Add(self.kz1text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        flnmlabel = wx.StaticText(panel_kz, -1, "KZ2:")
        flnmlabel.SetHelpText("End Y")
        hbox4.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.kz2text = wx.TextCtrl(panel_kz, -1, "", size=(-1,30))
        self.kz2text.SetHelpText("Set End   Z")
        self.kz2text.SetValue(str(defKZ2))
        
        hbox4.Add(self.kz2text, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        panel_kz.SetSizer(hbox4)

        
        vbox.Add(panel_kz, 0, wx.ALL|wx.EXPAND, 1)

        # maximum and minmum values

        panel_val=wx.Panel(panel_w, -1)
        hbox5=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_val, -1, "Vmin:")
        flnmlabel.SetHelpText("Minimal V")
        hbox5.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.vmintext = wx.TextCtrl(panel_val, -1, "", size=(-1,30))
        self.vmintext.SetHelpText("Set Minimal Values")
        self.vmintext.SetValue(str(defVmin))
        
        hbox5.Add(self.vmintext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        flnmlabel = wx.StaticText(panel_val, -1, "Vmax:")
        flnmlabel.SetHelpText("Maximal Values")
        hbox5.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.vmaxtext = wx.TextCtrl(panel_val, -1, "", size=(-1,30))
        self.vmaxtext.SetHelpText("Set Maximal Values")
        self.vmaxtext.SetValue(str(defVmax))
        
        hbox5.Add(self.vmaxtext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
       
        panel_val.SetSizer(hbox5)
        vbox.Add(panel_val, 0, wx.ALL|wx.EXPAND, 1)

        # set the convert factor and unit
        
        panel_unit=wx.Panel(panel_w, -1)
        hbox6=wx.BoxSizer(wx.HORIZONTAL)
                
        flnmlabel = wx.StaticText(panel_unit, -1, "Factor:")
        flnmlabel.SetHelpText("Unit Convert Factor")
        hbox6.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.factortext = wx.TextCtrl(panel_unit, -1, "", size=(-1,30))
        self.factortext.SetHelpText("Unit Convert Factor")
        self.factortext.SetValue(str(defFactor))
        
        hbox6.Add(self.factortext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)


        flnmlabel = wx.StaticText(panel_unit, -1, "Unit:")
        flnmlabel.SetHelpText("Unit")
        hbox6.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.unittext = wx.TextCtrl(panel_unit, -1, "", size=(-1,30))
        self.unittext.SetHelpText("Set Unit")
        self.unittext.SetValue(str(defUnit))
        
        hbox6.Add(self.unittext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        panel_unit.SetSizer(hbox6)
                
        vbox.Add(panel_unit, 0, wx.ALL|wx.EXPAND, 1)
        
        # set the file name if it is want to be saved
        panel_figure=wx.Panel(panel_w, -1)
        hbox7=wx.BoxSizer(wx.HORIZONTAL)
                
        flnmlabel = wx.StaticText(panel_figure, -1, "Figure Name:")
        flnmlabel.SetHelpText("File name to save figure")
        hbox7.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.fignametext = wx.TextCtrl(panel_figure, -1, "", size=(-1,30))
        self.fignametext.SetHelpText("Input file name for figure")
        self.fignametext.SetValue(str(defFigName))
        
        hbox7.Add(self.fignametext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        

        flnmlabel = wx.StaticText(panel_figure, -1, "Figure Title:")
        flnmlabel.SetHelpText("Unit")
        hbox7.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        self.figtitletext = wx.TextCtrl(panel_figure, -1, "", size=(-1,30))
        self.figtitletext.SetHelpText("Set Figure Title")
        self.figtitletext.SetValue(str(defFigTitle))
        
        hbox7.Add(self.figtitletext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        panel_figure.SetSizer(hbox7)
                
        vbox.Add(panel_figure, 0, wx.ALL|wx.EXPAND, 1)
        
        
        # sizer.Add(gs, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        line = wx.StaticLine(panel_w, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        vbox.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)
        
        btnsizer = wx.StdDialogButtonSizer()
        
        # if wx.Platform != "__WXMSW__":
        #    btn = wx.ContextHelpButton(self)
        #     btnsizer.AddButton(btn)
        
        btn = wx.Button(panel_w, wx.ID_OK)
        btn.SetHelpText("The OK button completes the dialog")
        
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(panel_w, wx.ID_CANCEL)
        btn.SetHelpText("The Cancel button cancels the dialog. (Cool, huh?)")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        
        vbox.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        vbox.Add((-1, 5))
        
        panel_w.SetSizer(vbox)
        vbox.Fit(panel_w)
        
        # self.Show()
        
        
    
    def OnClick_Browse_sp(self, event):
        wildcard = "data files (tra*.dat) |tra*.dat | All files (*.*)|*.*"
        dirname=self.dirname.strip()
        if (dirname==""):
            dirname=os.getcwd()
        
        
        dlg=wx.FileDialog(self, "Choose Tracer Info", dirname, "", wildcard=wildcard, \
                          style=wx.FD_OPEN | wx.CHANGE_DIR)
        dlg.SetFilterIndex(1)
        
        if (dlg.ShowModal()==wx.ID_OK):
            filename=dlg.GetFilename()
            dirname=dlg.GetDirectory()
            full_name=os.path.join(dirname, filename)
            self.spfiletext.SetValue(full_name)
            
        dlg.Destroy()
        return False

class MyFileDialog_sp(wx.Dialog):
    def __init__(self, parent, ID, title, defDir,
                 defSP="", \
                 defCategory="SP",\
                 defSPid=1,\
                 defTau=0,\
                 size=wx.DefaultSize, pos=wx.DefaultPosition, \
                 style=wx.DEFAULT_DIALOG_STYLE, useMetal=False):
        
        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.

        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)
        

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.

        self.PostCreate(pre)

        # This extra style can be set after the UI object has been created.
        if 'wxMac' in wx.PlatformInfo and useMetal:
            self.SetExtraStyle(wx.DIALOG_EX_METAL)
            
        
        # Now continue with the normal construction of the dialog
        # contents

        self.dirname=defDir
        
        panel_w=wx.Panel(self,-1, size=(500, -1))
        vbox=wx.BoxSizer(wx.VERTICAL)
        
        panel_file=wx.Panel(panel_w, -1)
        hbox1=wx.BoxSizer(wx.HORIZONTAL)
        
        # sizer = wx.BoxSizer(wx.VERTICAL)
        
        # box = wx.BoxSizer(wx.HORIZONTAL)

        # gs = wx.GridSizer(2, 3)
        
        flnmlabel = wx.StaticText(panel_file, -1, "Surface Pressure:")
        flnmlabel.SetHelpText("File Name")
        hbox1.Add(flnmlabel, 0, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        self.spfiletext = wx.TextCtrl(panel_file, -1, "", size=(300,30))
        self.spfiletext.SetHelpText("Enter Surface Pressure file name")
        self.spfiletext.SetValue(defSP)
        hbox1.Add(self.spfiletext, 1,  wx.ALIGN_CENTRE|wx.ALL,0)
        

        browsebtn_sp=wx.Button(panel_file, ID_BROWSE_SP, "Browse",  size=(80, 30))
        self.Bind(wx.EVT_BUTTON, self.OnClick_Browse_sp, browsebtn_sp)
        hbox1.Add(browsebtn_sp, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,0)

        panel_file.SetSizer(hbox1)
        vbox.Add(panel_file, 0, wx.ALL|wx.EXPAND, 1)

        
        # additional information for reading SP from bpch file
        panel_option=wx.Panel(panel_w, -1)
        hbox2=wx.BoxSizer(wx.HORIZONTAL)
        
        flnmlabel = wx.StaticText(panel_option, -1, "Category:")
        flnmlabel.SetHelpText("Additional information")
        hbox2.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)

        self.categorytext = wx.TextCtrl(panel_option, -1, "", size=(-1,30))
        self.categorytext.SetHelpText("Enter category for surface pressure")
        self.categorytext.SetValue(defCategory)
        
        hbox2.Add(self.categorytext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        flnmlabel = wx.StaticText(panel_option, -1, "ID:")
        flnmlabel.SetHelpText("Additional information")
        hbox2.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        
        self.spidtext = wx.TextCtrl(panel_option, -1, "", size=(-1,30))
        self.spidtext.SetHelpText("Enter ID for surface pressure")
        self.spidtext.SetValue(defSPid)
        
        hbox2.Add(self.spidtext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)

        flnmlabel = wx.StaticText(panel_option, -1, "TAU0:")
        flnmlabel.SetHelpText("Additional information")
        hbox2.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,  0)
        
        
        self.tautext = wx.TextCtrl(panel_option, -1, "", size=(-1,30))
        self.tautext.SetHelpText("Enter tau0 for surface pressure")
        self.tautext.SetValue(defTau)
        
        hbox2.Add(self.tautext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        panel_option.SetSizer(hbox2)
        
        vbox.Add(panel_option, 0, wx.ALL|wx.EXPAND, 1)
        
                
        # sizer.Add(gs, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        
        line = wx.StaticLine(panel_w, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        vbox.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)
        
        btnsizer = wx.StdDialogButtonSizer()
        
        # if wx.Platform != "__WXMSW__":
        #    btn = wx.ContextHelpButton(self)
        #     btnsizer.AddButton(btn)
        
        btn = wx.Button(panel_w, wx.ID_OK)
        btn.SetHelpText("The OK button completes the dialog")
        
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(panel_w, wx.ID_CANCEL)
        btn.SetHelpText("The Cancel button cancels the dialog. (Cool, huh?)")
        btnsizer.AddButton(btn)
        btnsizer.Realize()
        
        vbox.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        vbox.Add((-1, 5))
        
        panel_w.SetSizer(vbox)
        vbox.Fit(panel_w)
        
        # self.Show()
        
        
    
    def OnClick_Browse_sp(self, event):
        wildcard = "data files (tra*.dat) |tra*.dat | All files (*.*)|*.*"
        dirname=self.dirname.strip()
        if (dirname==""):
            dirname=os.getcwd()
        
        
        dlg=wx.FileDialog(self, "Choose Tracer Info", dirname, "", wildcard=wildcard, \
                          style=wx.FD_OPEN | wx.CHANGE_DIR)
        dlg.SetFilterIndex(1)
        
        if (dlg.ShowModal()==wx.ID_OK):
            filename=dlg.GetFilename()
            dirname=dlg.GetDirectory()
            full_name=os.path.join(dirname, filename)
            self.spfiletext.SetValue(full_name)
            
        dlg.Destroy()
        return False


class MyFileDialog_info(wx.Dialog):
    def __init__(self, parent, ID, title, defDir,
                 defTracer="", \
                 defDiag="", \
                 size=wx.DefaultSize, pos=wx.DefaultPosition, \
                 style=wx.DEFAULT_DIALOG_STYLE, useMetal=False):
        
        # Instead of calling wx.Dialog.__init__ we precreate the dialog
        # so we can set an extra style that must be set before
        # creation, and then we create the GUI object using the Create
        # method.

        pre = wx.PreDialog()
        pre.SetExtraStyle(wx.DIALOG_EX_CONTEXTHELP)
        pre.Create(parent, ID, title, pos, size, style)
        

        # This next step is the most important, it turns this Python
        # object into the real wrapper of the dialog (instead of pre)
        # as far as the wxPython extension is concerned.

        self.PostCreate(pre)

        # This extra style can be set after the UI object has been created.
        if 'wxMac' in wx.PlatformInfo and useMetal:
            self.SetExtraStyle(wx.DIALOG_EX_METAL)
            
        
        # Now continue with the normal construction of the dialog
        # contents
        sizer = wx.BoxSizer(wx.VERTICAL)
        self.dirname=defDir
        
        # box = wx.BoxSizer(wx.HORIZONTAL)

        gs = wx.GridSizer(2, 3)
        
        flnmlabel = wx.StaticText(self, -1, "TacerInfo:")
        flnmlabel.SetHelpText("File Name")
        gs.Add(flnmlabel, 0, wx.ALIGN_CENTRE|wx.ALL, 0)

        self.tracertext = wx.TextCtrl(self, -1, "", size=(250,30))
        self.tracertext.SetHelpText("Enter Tracer Info File Name")
        self.tracertext.SetValue(defTracer)
        gs.Add(self.tracertext, 1,  wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND,0)
        
        
        
        browsebtn_tracer=wx.Button(self, ID_BROWSE_TRACER, "Browse",  size=(80, 30))
        self.Bind(wx.EVT_BUTTON, self.OnClick_Browse_tracer, browsebtn_tracer)
        gs.Add(browsebtn_tracer, 0,  wx.ALIGN_CENTRE|wx.ALL,0)
        
        # sizer.Add(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        

        # box = wx.BoxSizer(wx.HORIZONTAL)

        flnmlabel = wx.StaticText(self, -1, "DiagInfo:")
        flnmlabel.SetHelpText("File Name")
        gs.Add(flnmlabel, 0,  wx.ALIGN_CENTRE|wx.ALL,  0)

        self.diagtext = wx.TextCtrl(self, -1, "", size=(250,30))
        self.diagtext.SetHelpText("Enter Tracer Info File Name")
        self.diagtext.SetValue(defDiag)
        gs.Add(self.diagtext, 1, wx.ALIGN_CENTRE|wx.ALL|wx.EXPAND, 0)
        
        
        browsebtn_diag=wx.Button(self, ID_BROWSE_DIAG, "Browse",  size=(80, 30))
        self.Bind(wx.EVT_BUTTON, self.OnClick_Browse_diag, browsebtn_diag)
        gs.Add(browsebtn_diag, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
        
        sizer.Add(gs, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)
        

        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)
        
        btnsizer = wx.StdDialogButtonSizer()
        
        # if wx.Platform != "__WXMSW__":
        #    btn = wx.ContextHelpButton(self)
        #     btnsizer.AddButton(btn)
        
        btn = wx.Button(self, wx.ID_OK)
        btn.SetHelpText("The OK button completes the dialog")
        
        btn.SetDefault()
        btnsizer.AddButton(btn)

        btn = wx.Button(self, wx.ID_CANCEL)
        btn.SetHelpText("The Cancel button cancels the dialog. (Cool, huh?)")
        btnsizer.AddButton(btn)
        btnsizer.Realize()

        sizer.Add(btnsizer, 0, wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        self.SetSizer(sizer)
        sizer.Fit(self)
        
    
    def OnClick_Browse_tracer(self, event):
        wildcard = "data files (tra*.dat) |tra*.dat | All files (*.*)|*.*"
        dirname=self.dirname.strip()
        if (dirname==""):
            dirname=os.getcwd()
        
        
        dlg=wx.FileDialog(self, "Choose Tracer Info", dirname, "", wildcard=wildcard, \
                          style=wx.FD_OPEN | wx.CHANGE_DIR)
        dlg.SetFilterIndex(1)
        
        if (dlg.ShowModal()==wx.ID_OK):
            filename=dlg.GetFilename()
            dirname=dlg.GetDirectory()
            full_name=os.path.join(dirname, filename)
            self.tracertext.SetValue(full_name)
            
        dlg.Destroy()
        return False

    def OnClick_Browse_diag(self, event):
        wildcard = "data files (diag*.dat) |diag*.dat | All files (*.*) |*.*"
        
        dirname=self.dirname.strip()
        if (dirname==""):
            dirname=os.getcwd()
        
        dlg=wx.FileDialog(self, "Choose Diag Info", dirname, "", wildcard=wildcard, \
                          style=wx.FD_OPEN | wx.CHANGE_DIR)
        dlg.SetFilterIndex(1)
        
        if (dlg.ShowModal()==wx.ID_OK):
            filename=dlg.GetFilename()
            dirname=dlg.GetDirectory()
            full_name=os.path.join(dirname, filename)
            self.diagtext.SetValue(full_name)
            
        dlg.Destroy()
        return False

class MainWindow(wx.Frame):
    def __init__(self, parent, id, title):

        # the setting need to keep
        self.dirname=""
        self.flnm=""
        self.tracerinfo="./diaginfo.dat"
        self.diaginfo="./tracerinfo.dat"
        self.sp_file="./GEOS5-SP.D20060101.nc"
        self.sp_category="SP"
        self.sp_id="*"
        self.sp_tau="*"
        self.current_sp=None
        self.val_list=None
        self.val_name_list=None
        
        self.save_fig_name=""
        self.fig_map=None
        self.fig_col=None
        self.fig_zon=None
        
        self.fig_title=""
        
        self.bpdata_list=None
        self.ifig=0

        self.IX2, self.JY2, self.KZ2=0,0,0
        self.IX1, self.JY1, self.KZ1=0,0,0
        # values for plots
        
        self.Vmin, self.Vmax=0,0
        self.Factor, self.Unit=1.0, ""
        
        

        try:
            deffile=open(default_setting_file, 'r')
            lines=deffile.readlines()
            deffile.close()
            
            for line in lines:
                if 'DIR:' in line:
                    terms=line.split()
                    self.dirname=terms[1].strip()
                elif 'FLNM' in line:
                    terms=line.split()
                    self.flnm=terms[1].strip()
                elif ('TRACERINFO:' in line):
                    terms=line.split()
                    self.tracerinfo=terms[1].strip()
                elif ('DIAGINFO:' in line):
                    terms=line.split()
                    self.diaginfo=terms[1].strip()
                    
                    
        except IOError:
            self.dirname="./enkf_output/"
            self.flnm="restart.EN0001-EN0024.20030101"
            self.fullname=self.dirname+self.flnm
            self.tracerinfo="./enkf_output/diaginfo.EN0001-EN0024.dat"
            self.diaginfo="./enkf_output/tracerinfo.EN0001-EN0024.dat"
        
        if (self.dirname in self.flnm):
            self.fullname=self.flnm
        else:
            self.fullname=self.dirname+'/'+self.flnm
        
        
        wx.Frame.__init__(self, parent, wx.ID_ANY, title, size=(880,800))
        # self.control=wx.TextCtrl(self, 1, style=wx.TE_MULTILINE)
        
        self.CreateStatusBar()
        
        filemenu=wx.Menu()
        filemenu.Append(ID_LOAD, "&Load", "Load BPCH2 FILE")
        filemenu.Append(ID_SAVE_SETTING, "&Save Setting", "Save Current Settings")
        filemenu.AppendSeparator()
        filemenu.Append(ID_EXIT, "E&xit", "Terminate the program")
        
        
        self.viewmenu=wx.Menu()
        self.viewmenu.Append(ID_VIEW_COL, "&Total Column", "view total column map")
        self.viewmenu.Append(ID_VIEW_ZM, "&Zonal Mean", "zonal mean")
        self.viewmenu.Append(ID_VIEW_MAP, "Map", "map at model lvl")
        self.viewmenu.AppendSeparator()
        self.viewmenu.Append(ID_VIEW_OP, "Opt&ion", "Select options for plot")

        self.viewmenu.Enable(ID_VIEW_COL,False)
        self.viewmenu.Enable(ID_VIEW_ZM,False)
        self.viewmenu.Enable(ID_VIEW_MAP,False)
        
        self.convertmenu=wx.Menu()
        self.convertmenu.Append(ID_CONVERT_REGRID, "&Regrid", "regrid fields")
        # self.convertmenu.Enable(ID_CONVERT_REGRID,False)
        

        # animation

        self.animatemenu=wx.Menu()
        self.animatemenu.Append(ID_ANIMATE_COL, "&Total Column", "animate total column map")
        self.animatemenu.Append(ID_ANIMATE_ZM, "&Zonal Mean", "zonal mean")
        self.animatemenu.Append(ID_ANIMATE_MAP, "Map", "map at model lvl")
        self.animatemenu.AppendSeparator()
        self.animatemenu.Append(ID_ANIMATE_OP, "Opt&ion", "Select options for plot")

        self.animatemenu.Enable(ID_ANIMATE_COL,False)
        self.animatemenu.Enable(ID_ANIMATE_ZM,False)
        self.animatemenu.Enable(ID_ANIMATE_MAP,False)
        
        
        
        
        setmenu=wx.Menu()
        setmenu.Append(ID_SET, "Ch&oose Info", "Set Tracer & Diag Info files")
        setmenu.Append(ID_SELECT_SP, "Choose Surface P&ressure", "Select surface pressure file")
        
        helpmenu=wx.Menu()
        helpmenu.Append(ID_ABOUT, "&About", "About wx BPCH dump")
        
        menuBar=wx.MenuBar()
        menuBar.Append(filemenu, "&File")
        menuBar.Append(self.viewmenu, "&Plot")
        menuBar.Append(self.animatemenu, "&Animate")
        menuBar.Append(self.convertmenu, "&Convert")
        
        menuBar.Append(setmenu, "&Configure")
        menuBar.Append(helpmenu, "&Help")
        
        
        wx.EVT_MENU(self, ID_ABOUT, self.OnAbout)
        wx.EVT_MENU(self, ID_EXIT, self.OnExit)
        wx.EVT_MENU(self, ID_LOAD, self.OnLoad)
        wx.EVT_MENU(self, ID_SAVE_SETTING, self.OnSaveSetting)
        wx.EVT_MENU(self, ID_SET, self.OnSet)

        wx.EVT_MENU(self, ID_SELECT_SP, self.OnSelectSP)
        wx.EVT_MENU(self, ID_VIEW_ZM, self.OnViewZonalMean)
        wx.EVT_MENU(self, ID_VIEW_COL, self.OnViewTotalColumn)
        wx.EVT_MENU(self, ID_VIEW_MAP, self.OnViewMap)
        wx.EVT_MENU(self, ID_VIEW_OP, self.OnViewOption)

        wx.EVT_MENU(self, ID_ANIMATE_ZM, self.OnAnimateZonalMean)
        wx.EVT_MENU(self, ID_ANIMATE_COL, self.OnAnimateTotalColumn)
        wx.EVT_MENU(self, ID_ANIMATE_MAP, self.OnAnimateMap)
        wx.EVT_MENU(self, ID_ANIMATE_OP, self.OnAnimateOption)
        
        wx.EVT_MENU(self, ID_CONVERT_REGRID, self.OnConvertRegrid)
        


        self.SetMenuBar(menuBar)
        # set up the list box
        
        
        self.il = wx.ImageList(16, 16)
        self.idx1 = self.il.Add(images.getSmilesBitmap())
        self.sm_up = self.il.Add(images.getSmallUpArrowBitmap())
        self.sm_dn = self.il.Add(images.getSmallDnArrowBitmap())
        bmp_browse=wx.Bitmap('./minus4.ico')
        

        panel_w=wx.Panel(self,-1)
        vbox=wx.BoxSizer(wx.VERTICAL)
        
        panel_file=wx.Panel(panel_w, -1)
        hbox1=wx.BoxSizer(wx.HORIZONTAL)
        
        label_file=wx.StaticText(panel_file, -1, 'File Name:')
        hbox1.Add(label_file, 0, wx.ALL|wx.ALIGN_RIGHT,10)
        self.text_file=wx.TextCtrl(panel_file, -1, size=(-1, 30))
        self.text_file.SetValue(self.fullname)
        hbox1.Add(self.text_file, 1, wx.RIGHT|wx.TOP|wx.BOTTOM|wx.ALIGN_CENTRE_HORIZONTAL|wx.EXPAND,10)
        self.browsebtn=wx.BitmapButton(panel_file, ID_BROWSE, bmp_browse,  size=(30, 30))
        self.Bind(wx.EVT_BUTTON, self.OnClick_Browse, self.browsebtn)
        hbox1.Add(self.browsebtn, 0, wx.RIGHT|wx.TOP|wx.BOTTOM|wx.ALIGN_RIGHT,10)
        
        self.loadbtn=wx.Button(panel_file, ID_LOAD, "Load",  size=(60, 30))
        hbox1.Add(self.loadbtn, 0, wx.ALL,10)
        self.Bind(wx.EVT_BUTTON, self.OnLoad, self.loadbtn)
        
        
        panel_file.SetSizer(hbox1)
        vbox.Add(panel_file, 0, wx.ALL|wx.EXPAND, 1)
        
        
        
        panel_list=wx.Panel(panel_w, -1)
        
                
        self.infolist=wx.ListCtrl(panel_list, -1, style=wx.LC_REPORT)
        self.currentItem=-1
        
        self.infolist.SetImageList(self.il, wx.IMAGE_LIST_SMALL)
        
        self.infolist.InsertColumn(0, 'No')
        self.infolist.InsertColumn(1, 'Category')
        self.infolist.InsertColumn(2, 'Name')
        self.infolist.InsertColumn(3, 'Unit')
        self.infolist.InsertColumn(4, 'TAU0')
        self.infolist.InsertColumn(5, 'TAU1')
        self.infolist.InsertColumn(6, 'NX')
        self.infolist.InsertColumn(7, 'NY')
        self.infolist.InsertColumn(8, 'NZ')
        self.infolist.InsertColumn(9, 'Max')
        self.infolist.InsertColumn(10, 'Min')
        
         
        
        
        
        self.infolist.SetColumnWidth(0, 80)
        self.infolist.SetColumnWidth(1, 80)
        self.infolist.SetColumnWidth(2, 80)
        self.infolist.SetColumnWidth(3, 80)
        self.infolist.SetColumnWidth(4, 100)
        self.infolist.SetColumnWidth(5, 100)
        self.infolist.SetColumnWidth(6, 40)
        self.infolist.SetColumnWidth(7, 40)
        self.infolist.SetColumnWidth(8, 40)
        self.infolist.SetColumnWidth(9, 120)
        self.infolist.SetColumnWidth(10, 120)

        
        self.Bind(wx.EVT_LIST_ITEM_SELECTED, self.OnItemSelected, self.infolist)
        self.Bind(wx.EVT_LIST_ITEM_DESELECTED, self.OnItemDeselected, self.infolist)
        # self.Bind(wx.EVT_LIST_ITEM_ACTIVATED, self.OnItemActivated, self.infolist)

        
        self.infolist.Bind(wx.EVT_LEFT_DCLICK, self.OnDoubleClick)
        
        sizer = wx.BoxSizer(wx.VERTICAL)
        sizer.Add(self.infolist, 1, wx.ALL|wx.EXPAND|wx.ALIGN_CENTER_VERTICAL, 1)
        sizer.Add((-1, 5))
        panel_list.SetSizer(sizer)

        vbox.Add(panel_list,1, wx.ALL|wx.EXPAND|wx.ALIGN_CENTER_VERTICAL, 5)

        panel_vals=wx.Panel(panel_w, -1)

        hbox=wx.BoxSizer(wx.HORIZONTAL)
        
        label_x=wx.StaticText(panel_vals, -1, 'IX:', size=(30,30))
        hbox.Add(label_x, 0, wx.ALL|wx.ALIGN_RIGHT,10)
        self.text_x=wx.TextCtrl(panel_vals, -1, style=wx.TE_PROCESS_ENTER, size=(-1, 30))
        hbox.Add(self.text_x, 1, wx.ALL|wx.ALIGN_RIGHT|wx.EXPAND,10)
        self.text_x.SetValue('0')
        self.text_x.Enable(False)
        self.text_x.Bind(wx.EVT_TEXT_ENTER, self.EvtTextEnter_x)
        self.text_x.Bind(wx.EVT_KILL_FOCUS, self.EvtTextKillFocus_x)
        
          
        label_y=wx.StaticText(panel_vals, -1, 'IY:', size=(30,30))
        hbox.Add(label_y, 0, wx.ALL|wx.ALIGN_RIGHT,10)
        self.text_y=wx.TextCtrl(panel_vals, -1, style=wx.TE_PROCESS_ENTER,size=(-1, 30))
        hbox.Add(self.text_y, 1, wx.ALL|wx.ALIGN_RIGHT|wx.EXPAND,10)
        self.text_y.SetValue('0')
        self.text_y.Enable(False)
        self.Bind(wx.EVT_TEXT_ENTER, self.EvtTextEnter_y, self.text_y)
        self.text_y.Bind(wx.EVT_KILL_FOCUS, self.EvtTextKillFocus_y)
        
        
        label_z=wx.StaticText(panel_vals, -1, 'IZ:', size=(30,30))
        hbox.Add(label_z, 0, wx.ALL|wx.ALIGN_RIGHT,10)
        self.text_z=wx.TextCtrl(panel_vals, -1,style=wx.TE_PROCESS_ENTER,size=(-1,30))
        hbox.Add(self.text_z, 1, wx.ALL|wx.ALIGN_RIGHT|wx.EXPAND,10)
        self.text_z.SetValue('0')
        self.text_z.Enable(False)
        self.Bind(wx.EVT_TEXT_ENTER, self.EvtTextEnter_z, self.text_z)
        self.text_z.Bind(wx.EVT_KILL_FOCUS, self.EvtTextKillFocus_z)
        
        
        label_v=wx.StaticText(panel_vals, -1, 'VAL:', size=(60,30))
        hbox.Add(label_v, 0, wx.ALL|wx.ALIGN_LEFT,10)
        self.text_v=wx.TextCtrl(panel_vals, -1 , size=(-1,30))
        hbox.Add(self.text_v, 1, wx.ALL|wx.ALIGN_LEFT|wx.EXPAND,10)
        self.text_v.Enable(False)
        self.ix, self.iy, self.iz=0,0,0
        
        panel_vals.SetSizer(hbox)
        # panel python  #
            
        vbox.Add(panel_vals, 0, wx.ALL|wx.EXPAND, 1)
        self.err_on=False

        self.panel_cmd=wx.Panel(panel_w, -1)
        # locals={'cur_l':cur_l, 'test_d':test_d}
        # self.myshell=pysh.shell.Shell(self.panel_cmd, -1,locals=locals, size=(850, 300))
        # help(self.myshell)
        self.myshell=pysh.shell.Shell(self.panel_cmd, -1 ,size=(850, 300))
        
        # vbox.Add(self.panel_cmd, 1, wx.ALL|wx.EXPAND|wx.ALIGN_CENTRE_HORIZONTAL, 10)
        # vbox.Add(self.panel_cmd, 1, wx.ALL|wx.EXPAND|wx.ALIGN_CENTRE_HORIZONTAL, 10)
        
        vbox.Add(self.panel_cmd, 0, wx.ALL|wx.ALIGN_RIGHT|wx.ALIGN_LEFT, 10)
        
        vbox.Add((-1, 5))
        panel_w.SetSizer(vbox)
        
        # panel list
        
        self.Centre()
        
        self.Show(True)
        
    def OnAbout(self, event):
        d=wx.MessageDialog(self, "The program to read bpch files", "BPCH Dump", wx.OK)
        d.ShowModal()
        d.Destroy()

    def OnSaveSetting(self, event):
        deffile=open(default_setting_file, 'w')
        deffile.write('DIR: '+self.dirname+'\n')
        deffile.write('FLNM: '+self.flnm+'\n')
        deffile.write('TRACERINFO: '+self.tracerinfo+'\n')
        deffile.write('DIAGINFO: '+self.diaginfo+'\n')
        deffile.close()
    
    def OnExit(self, event):
        # save the current file
        
        self.Close(True)

    def OnViewZonalMean(self, event):
        
        print '=====> :  OnViewZonalMean'
        
        
        # import bpch2_rw_v2 as brw
        
        do_prof_test=False
        
        
        if (self.currentItem<0):
            return 1
        

        bpdata=self.bpdata_list[self.currentItem]
        figure(self.ifig)
        self.ifig=self.ifig+1
        
        # subplot(2,1,1)
        
        pressure=self.cal_cur_pressure(bpdata)
        
        pres_lvl=arange(-3, 0.1, 1.0/12.0)
        pres_lvl=10**(-pres_lvl)
        rlon=bpdata.grid.get_lon()
        rlat=bpdata.grid.get_lat()
        nlon=size(rlon)
        nlat=size(rlat)
            
        if (do_prof_test):
            figure(4)
            subplot(2,1,1)
            plot(1.0e6*bpdata.data[nlon/2, nlat/2, :], pressure[nlon/2, nlat/2,:], 'r')
            plot(1.0e6*bpdata.data[nlon/2, nlat/2+5, :], pressure[nlon/2, nlat/2,:], 'r--')
            
        vals=fgrd.get_model_zonal_mean(bpdata.data, pressure, pres_lvl)

        maxv=self.Vmax
        minv=self.Vmin
        unit=bpdata.unit
        
        if (len(self.Unit)>0):
            unit=self.Unit

        factor=self.Factor
        
        unit=unit.strip()
        if (len(unit)==0):
            unit='v/v (?)'
            
            
        
        if ((factor<=1) & ('v/v' in unit)):
            
            if (max(vals.flat)<1000.e-9):
                factor=1.0e9
                unit='ppb'
            elif (max(vals.flat)<1000.e-6):
                factor=1.0e6
                unit='ppm'
        
        if (maxv<=minv):
            maxv=max(vals.flat)
            maxv=factor*maxv
            vals=where(vals<-900.0, maxv+900.0,factor*vals)
            minv=min(vals.flat)
            vals=where(vals>maxv, minv,vals)
        else:
            vals=where(vals<-900.0, vals,factor*vals)
        
        dv=(maxv-minv)/10.0
        
        stitle=r"ID=%2.2d ZM-" % bpdata.ntracer
        
        
        
        if ('name' in bpdata.attr):
            add_str=bpdata.attr['name']
        else:
            add_str=bpdata.category
        
        add_str=add_str.strip()
        stitle=stitle+' '+add_str
        stitle=stitle+' ('+unit.strip()+')'
            
            
        if ('tau0' in bpdata.attr):
            tau0=bpdata.attr['tau0']
            tau0=3600.*tau0 # convert to seconds
            utc=tm.tai85_to_utc(tau0)
            utc=utc.replace('-', '')
            stitle=stitle+' '+utc
            
        if (do_prof_test):
            plot(vals[nlat/2, :], pres_lvl, 'b')
            plot(vals[nlat/2+5, :], pres_lvl, 'b--')
            xlim([330, 380])
            ylim([1000, 100])
            title(stitle)
            show()
            
        # output the data
       
        
        # dimnames=['lat', 'pressure']
        # dimvars=[rlat, pres_lvl]
        # dimtypes=['f', 'f']
        
        lat_info=ovar.io_var_cl('lat', 'f', ['lat'], rlat)
        pres_info=ovar.io_var_cl('pressure', 'f', ['pressure'], pres_lvl)
        
        ovals_info=ovar.io_var_cl('zonal_mean', 'f', ['lat', 'pressure'], vals,\
                                    varattr={"unit":"unitless", "desc":"zonal mean"})
        obsflnm="view_zonal"+".nc"
        ncfio.ncf_save_var(obsflnm, [ovals_info], [lat_info, pres_info],  create_new=True)
        
        if (self.fig_title<>""):
             stitle=self.fig_title
                
        gpl.plot_zonal_mean(vals[self.JY1:self.JY2,:], pres_lvl, rlat[self.JY1:self.JY2],\
                            use_pcolor=1, \
                            maxv=maxv, minv=minv, dv=dv, title=stitle, use_log=1,\
                            cbar_vert=0)

        # the file name to save figure
         
        if (self.save_fig_name<>""):
            savefig(self.save_fig_name.strip())    
        
        show()
        
            
    def OnViewTotalColumn(self, event):
        # import bpch2_rw_v2 as brw
        # import oco_feedback as ofb

        print '=====> :  OnViewTotalColumn'
        
        do_prof_test=False
        
 
        if (self.currentItem<0):
            return 0

        bpdata=self.bpdata_list[self.currentItem]
        figure(self.ifig)
        self.ifig=self.ifig+1
        # subplot(2,1,1)
        pressure=self.cal_cur_pressure(bpdata)
        
            
        
        # pres_lvl=arange(-3, 1.1, 1.0/12.0)
        # pres_lvl=10**(-pres_lvl)
        rlon=bpdata.grid.get_lon()
        rlat=bpdata.grid.get_lat()
        nlon=size(rlon)
        nlat=size(rlat)
            
        if (do_prof_test):
            figure(4)
            subplot(2,1,1)
            plot(1.0e6*bpdata.data[nlon/2, nlat/2, :], pressure[nlon/2, nlat/2,:], 'r')
            plot(1.0e6*bpdata.data[nlon/2, nlat/2+5, :], pressure[nlon/2, nlat/2,:], 'r--')
            
        vals=fgrd.get_model_colum(bpdata.data[:,:,self.KZ1:self.KZ2], \
                                  pressure[:,:,self.KZ1:self.KZ2])
        

        maxv=self.Vmax
        minv=self.Vmin
        unit=bpdata.unit
        
        if (len(self.Unit)>0):
            unit=self.Unit
        
        unit=unit.strip()
        if (len(unit)==0):
            unit='v/v (?)'
        
        factor=self.Factor
        
        if ((factor<=1) & ('v/v' in unit)):
            if (max(vals.flat)<1000.e-9):
                factor=1.0e9
                unit='ppb'
            elif (max(vals.flat)<1000.e-6):
                factor=1.0e6
                unit='ppm'
        
        if (maxv<=minv):
            maxv=max(vals.flat)
            maxv=factor*maxv
            vals=where(vals<-900.0, maxv+900.0,factor*vals)
            minv=min(vals.flat)
            vals=where(vals>maxv, minv,vals)
        else:
            vals=where(vals<-900.0, vals,factor*vals)
        
        dv=(maxv-minv)/10.0
        
        stitle=r"ID=%2.2d COL-" % bpdata.ntracer
        
        if ('name' in bpdata.attr):
            add_str=bpdata.attr['name']
        else:
            add_str=bpdata.category

        add_str=add_str.strip()
        stitle=stitle+' '+add_str
        stitle=stitle+' ('+unit.strip()+')'
            
        
        if ('tau0' in bpdata.attr):
            tau0=bpdata.attr['tau0']
            tau0=3600.*tau0 # convert to seconds
            utc=tm.tai85_to_utc(tau0)
            utc=utc.replace('-', '')
            stitle=stitle+' '+utc
            
        if (do_prof_test):
            plot(vals[nlat/2, :], pres_lvl, 'b')
            plot(vals[nlat/2+5, :], pres_lvl, 'b--')
            xlim([330, 380])
            ylim([1000, 100])
            title(stitle)
            show()
            
        # longitude range
        minlon=rlon[self.IX1]
        maxlon=rlon[self.IX2-1]
        if (maxlon>170.0):
            maxlon=180.0
        
        # latitude range
        
        minlat=rlat[self.JY1]
        maxlat=rlat[self.JY2-1]
        
        cmap=cm.jet
        # the file name to save figure
        if (self.fig_title<>""):
            stitle=self.fig_title
                
        # output the data
        # dimnames=['lon', 'lat']
        # dimvars=[rlon, rlat]
        # dimtypes=['f', 'f']
        
        lon_info=ovar.io_var_cl('lon', 'f', ['lon'], rlon,\
                                    varattr={"unit":"Degree East", "desc":"Longitude"})
        lat_info=ovar.io_var_cl('lat', 'f', ['lat'], rlat,\
                                    varattr={"unit":"Degree North", "desc":"Latitude"})
            
            

        ovals_info=ovar.io_var_cl('total_column', 'f', ['lon', 'lat'], vals,\
                                      varattr={"unit":"unknown", "desc":"total column"})
        obsflnm="view_column"+".nc"
        
        # ofb.ncf_write_by_varinfo(obsflnm, dimnames, dimtypes, dimvars, [ovals_info])
        
        ncfio.ncf_save_var(obsflnm,  [ovals_info], [lon_info, lat_info], create_new=True)
            
        
        gpl.plot_map(vals, rlon, rlat,use_pcolor=1, \
                     maxv=maxv, minv=minv, dv=dv, \
                     minlon=minlon, maxlon=maxlon,\
                     minlat=minlat, maxlat=maxlat,\
                     cmap=cmap,\
                     cbar_vert=0,\
                     title=stitle)
        
        # the file name to save figure
         
        if (self.save_fig_name<>""):
            savefig(self.save_fig_name.strip())    
        
        show()

    def OnViewMap(self, event):
        

        print '======> OnViewMap'
        
        if (self.currentItem>=0):
            bpdata=self.bpdata_list[self.currentItem]
            rlon=bpdata.grid.get_lon()
            rlat=bpdata.grid.get_lat()
            print 'rlon 0:-1', rlon[0], rlon[-1]

            print 'rlat 0:-1', rlat[0], rlat[-1]
            
            
            nlon=size(rlon)
            nlat=size(rlat)
            
            figure(self.ifig)
            self.ifig=self.ifig+1
            # subplot(2,1,1)
            
            vals=bpdata.data[:,:,self.KZ1]

            maxv=self.Vmax
            minv=self.Vmin
            unit=bpdata.unit
            factor=self.Factor
            
            if (len(self.Unit)>0):
                unit=self.Unit
            unit=unit.strip()
            
            if (len(unit)==0):
                unit='v/v (?)'
            
            
                
            if ((factor<=1) & ('v/v' in unit)):
                if (max(vals.flat)<1000.e-9):
                    factor=1.0e9
                    unit='ppb'
                elif (max(vals.flat)<1000.e-6):
                    factor=1.0e6
                    unit='ppm'
        
            if (maxv<=minv):
                maxv=max(vals.flat)
                maxv=factor*maxv
                vals=where(vals==-999.0, maxv+900.0,factor*vals)
                minv=min(vals.flat)
                vals=where(vals>maxv, minv,vals)
            else:
                vals=where(vals==-999.0, vals,factor*vals)
            
            dv=(maxv-minv)/10.0
        
            stitle=r"ID=%2.2d L=%2.2d-" % (bpdata.ntracer, self.KZ1)
            
            if ('name' in bpdata.attr):
                add_str=bpdata.attr['name']
            else:
                add_str=bpdata.category
                
            # add_str="CASA" 
            
            add_str=add_str.strip()
            stitle=stitle+' '+add_str
            stitle=stitle+' ('+unit.strip()+')'
            
            
            if ('tau0' in bpdata.attr):
                tau0=bpdata.attr['tau0']
                tau0=3600.*tau0 # convert to seconds
                utc=tm.tai85_to_utc(tau0)
                utc=utc.replace('-', '')
                # utc=utc[4:]
                # utc="2006"+utc
                
                stitle=stitle+' '+utc
                
             
            # longitude range
            minlon=min(rlon)
            maxlon=max(rlon)

            if (maxlon>170.0):
                maxlon=180.0
        
            # latitude range
        
            minlat=min(rlat)
            maxlat=max(rlat)
            
            # the file name to save figure
            if (self.fig_title<>""):
                stitle=self.fig_title
            

            # the figure title to draw
            
            # if (self.fig_map<>None):
            #    self.fig_map.clear()
            
            # else:
            #    self.fig_map=figure(FIG_MAP_ID)
            
            cmap=cm.jet

            # output the data
            # dimnames=['lon', 'lat']
            # dimvars=[rlon, rlat]
            # dimtypes=['f', 'f']
            print shape(vals), shape(rlon), shape(rlat)
            
            lon_info=ovar.io_var_cl('lon', 'f', ['lon'], rlon,\
                                        varattr={"unit":"Degree East", "desc":"Longitude"})
            lat_info=ovar.io_var_cl('lat', 'f', ['lat'], rlat,\
                                        varattr={"unit":"Degree North", "desc":"Latitude"})
            
            ovals_info=ovar.io_var_cl('map', 'f', ['lon', 'lat'], vals,\
                                          varattr={"unit":"unitless", "desc":"map"})
            obsflnm="~/view_map"+".nc"
            
            ncfio.ncf_save_var(obsflnm,  [ovals_info], [lon_info, lat_info], create_new=True)
            print 'Writing data to'+' '+obsflnm
            print 'max min',  max(vals.flat), min(vals.flat)
            
            gpl.plot_map(vals, rlon, rlat,use_pcolor=1, \
                         maxv=maxv, minv=minv, dv=dv, \
                         minlon=minlon, maxlon=maxlon,\
                         minlat=minlat, maxlat=maxlat,\
                         cmap=cmap,\
                         cbar_vert=1,\
                         title=stitle)
            show()
            
            # if (self.save_fig_name<>""):


            # savefig(self.save_fig_name.strip())
            
                
            # self.fig_map.show()
            
            
            
            

    def OnAnimateMap(self, event):
        
        import time
        import wx
        

        print '======> OnAnimateMap'
        
        
        if (self.currentItem>=0):
            bpdata=self.bpdata_list[self.currentItem]
            rlon=bpdata.grid.get_lon()
            rlat=bpdata.grid.get_lat()
            print 'rlon 0:-1', rlon[0], rlon[-1]

            print 'rlat 0:-1', rlat[0], rlat[-1]
            
            
            nlon=size(rlon)
            nlat=size(rlat)
            print 'size--lon--lat', nlon, nlat
            
            lfig=figure(self.ifig)
            
            self.ifig=self.ifig+1
            # subplot(2,1,1)
            
            vals=bpdata.data[:,:,self.KZ1]

            maxv=self.Vmax
            minv=self.Vmin
            unit=bpdata.unit
            
            if (len(self.Unit)>0):
                unit=self.Unit
                
            factor=self.Factor
            
            unit=unit.strip()
            if (len(unit)==0):
                unit='v/v (?)'
            
            
            
            if ((factor<=1) & ('v/v' in unit)):
                if (max(vals.flat)<1000.e-9):
                    factor=1.0e9
                    unit='ppb'
                elif (max(vals.flat)<1000.e-6):
                    factor=1.0e6
                    unit='ppm'
            
            if (maxv<=minv):
                maxv=max(vals.flat)
                maxv=factor*maxv
                vals=where(vals<-900.0, maxv+900.0,factor*vals)
                minv=min(vals.flat)
                vals=where(vals>maxv, minv,vals)
            else:
                vals=where(vals<-900.0, vals,factor*vals)
        
            dv=(maxv-minv)/10.0
        
            stitle=r"ID=%2.2d L=%2.2d-" % (bpdata.ntracer, self.KZ1)
            
        
     #       stitle=r'L=%2.2d ' % self.KZ1
            
            
            if ('name' in bpdata.attr):
                add_str=bpdata.attr['name']
            else:
                add_str=bpdata.category

            add_str=add_str.strip()
            stitle=stitle+' '+add_str
            stitle=stitle+' ('+unit.strip()+')'
            
        
            if ('tau0' in bpdata.attr):
                tau0=bpdata.attr['tau0']
                tau0=3600.*tau0 # convert to seconds
                utc=tm.tai85_to_utc(tau0)
                utc=utc.replace('-', '')
                stitle=stitle+' '+utc
                
             
            # longitude range
            minlon=rlon[self.IX1]
            maxlon=rlon[self.IX2-1]
            if (maxlon>170.0):
                maxlon=180.0
        
            # latitude range
            
            minlat=rlat[self.JY1]
            maxlat=rlat[self.JY2-1]
            
            cbar_vert=0
            cmap=cm.jet
            plot_keywords={}
            plot_keywords.update({'maxv':maxv})
            plot_keywords.update({'minv':minv})
            plot_keywords.update({'dv':dv})
            plot_keywords.update({'minlon':minlon})
            plot_keywords.update({'maxlon':maxlon})
            plot_keywords.update({'cmap':cmap})
            plot_keywords.update({'title':stitle})
            plot_keywords.update({'cbar_vert':cbar_vert})
            
                                 
            

            #
            data_flnm=self.flnm.strip()
            last_path=-1
            ch_cnt=0
            for ich in data_flnm:
                if (ich=='/'):
                    last_path=ch_cnt
                ch_cnt=ch_cnt+1
            
            
            if (last_path<0):
                data_dir=self.dirname.strip()
                if (len(data_dir)==0):
                    data_dir="./"
            else:
                data_dir=data_flnm[0:last_path]
                data_flnm=data_flnm[last_path+1:]
            
            print 'data_flnm', data_flnm
            pos_end=-1
            flcur_yyyy=1999
            while (pos_end<0):
                flcur_yyyy=flcur_yyyy+1
                
                try:
                    pos_end=data_flnm.index(str(flcur_yyyy))
                
                except  ValueError:
                    pos_end=-1
                
            
            short_flnm=data_flnm[0:pos_end]
            
            # print 'short_flnm', short_flnm
            # print flcur_yyyy, pos_end
            # ttt=raw_input()
            
            file_list=os_cmd.listdir(data_dir)
            choose_fl_list=list()
            
            category_in=bpdata.category
            tracer_in=bpdata.ntracer
            tau0_in=None
            
            for data_fl in file_list:
               if (short_flnm in data_fl):
                   choose_fl_list.append(data_fl)
                   
            
            print 'number of files', len(choose_fl_list)
            choose_fl_list=array(choose_fl_list)
            choose_fl_list=sort(choose_fl_list)
            
            all_val=list()
            first_val=array(vals)
            self.val_name_list=choose_fl_list
            
            for data_fl in choose_fl_list[0:]:
                full_data_fl=self.dirname+"/"+data_fl
                print full_data_fl
                
                # print 'tracer_in..', tracer_in
                
                
                
                category_out,tracer_out,unit_out,\
                    tau0_out,out_array= \
                    fgrd.get_model_value(full_data_fl, \
                                             category=category_in, tracer=tracer_in, tau0=tau0_in)
                # print 'max--val', max(out_array.flat)
                vals=out_array[:,:,self.KZ1]
                vals=squeeze(vals)
                
                if (maxv<=minv):
                    maxv=max(vals.flat)
                    maxv=factor*maxv
                    vals=where(vals<-900.0, maxv+900.0,factor*vals)
                    minv=min(vals.flat)
                    vals=where(vals>maxv, minv,vals)
                else:
                    vals=where(vals<-900.0, vals,factor*vals)
                
                    
                all_val.append(vals)
                
                # print 'max--val', max(vals.flat)
                # du=raw_input()
                
                # dlg.plot_map(vals, rlon=rlon, rlat=rlat,use_pcolor=1,
                #             keywords=plot_keywords)
                # dlg.cs0.set_array(vals)
                # dlg.figure.canvas.draw()
                

                # dlg.Show()
                # time.sleep(10)
                

            self.val_list=all_val
            
            dlg = wmplot.CanvasFrame(self, -1, "Setting Plot Parameters",\
                                     first_val, rlon, rlat,use_pcolor=1, \
                                     size=(600, 200),\
                                     style=wx.DEFAULT_DIALOG_STYLE,  \
                                     val_list=self.val_list, val_name_list=self.val_name_list,\
                                     plot_keywords=plot_keywords) 
            
            print ' I have reached here'
            # tx=arange(0.0, 2*pi, pi/300.0)
            icount=0
            # dlg.SetActive(True)
            # t = wx.Timer(dlg, dlg.TIMER_ID)
            # t.Start(20)
                
            # for vals in all_val:
                # dlg.ax.title=choose_fl_list[icount]
                # dlg.cs0.set_array(transpose(vals))
                # dlg.figure.canvas.draw()
                # tz=sin(tx)

                # icount=icount+1
            # del flg
            # self.SetActive(True)
            
            # del lfig
            
            # time.sleep(10)
                
        # show()
        
            
            
            
    def OnAnimateZonalMean(self, event):
        
        # import bpch2_rw_v2 as brw
        

        print '======> OnAnimateZonalMean'
        
        
        if (self.currentItem>=0):
            bpdata=self.bpdata_list[self.currentItem]
            rlon=bpdata.grid.get_lon()
            rlat=bpdata.grid.get_lat()
            bpdata=self.bpdata_list[self.currentItem]
            nlon=size(rlon)
            nlat=size(rlat)
            
            figure(self.ifig)
            self.ifig=self.ifig+1
            # subplot(2,1,1)
        
            pressure=self.cal_cur_pressure(bpdata)
            
            pres_lvl=arange(-3, 0.1, 1.0/12.0)
            pres_lvl=10**(-pres_lvl)
            rlon=bpdata.grid.get_lon()
            rlat=bpdata.grid.get_lat()
            nlon=size(rlon)
            nlat=size(rlat)
            
            vals=fgrd.get_model_zonal_mean(bpdata.data, pressure, pres_lvl)
            
            maxv=self.Vmax
            minv=self.Vmin
            unit=bpdata.unit
            if (len(self.Unit)>0):
                unit=self.Unit
            
            factor=self.Factor
        
            unit=unit.strip()
            if (len(unit)==0):
                unit='v/v (?)'
            
            
            
            if ((factor<=1) & ('v/v' in unit)):
            
                if (max(vals.flat)<1000.e-9):
                    factor=1.0e9
                    unit='ppb'
                elif (max(vals.flat)<1000.e-6):
                    factor=1.0e6
                    unit='ppm'
            
            if (maxv<=minv):
                maxv=max(vals.flat)
                maxv=factor*maxv
                vals=where(vals<-900.0, maxv+900.0,factor*vals)
                minv=min(vals.flat)
                vals=where(vals>maxv, minv,vals)
            else:
                vals=where(vals<-900.0, vals,factor*vals)
                
            dv=(maxv-minv)/20.0
            
            stitle=r"ID=%2.2d ZM-" % bpdata.ntracer
            if ('name' in bpdata.attr):
                add_str=bpdata.attr['name']
            else:
                add_str=bpdata.category
        
            add_str=add_str.strip()
            stitle=stitle+' '+add_str
            stitle=stitle+' ('+unit.strip()+')'
            
            
            if ('tau0' in bpdata.attr):
                tau0=bpdata.attr['tau0']
                tau0=3600.*tau0 # convert to seconds
                utc=tm.tai85_to_utc(tau0)
                utc=utc.replace('-', '')
                stitle=stitle+' '+utc
    

                data_flnm=self.flnm.strip()
            last_path=-1
            ch_cnt=0
            first_vals=array(vals)
            
            for ich in data_flnm:
                if (ich=='/'):
                    last_path=ch_cnt
                ch_cnt=ch_cnt+1
            
            
            if (last_path<0):
                data_dir=self.dirname.strip()
                if (len(data_dir)==0):
                    data_dir="./"
            else:
                data_dir=data_flnm[0:last_path]
                data_flnm=data_flnm[last_path+1:]
            
            print 'data_flnm', data_flnm

            pos_end=-1
            flcur_yyyy=1999


            minlat=rlat[self.JY1]
            maxlat=rlat[self.JY2-1]
            cbar_vert=0
            cmap=cm.jet
            yticks=[1000, 100, 10, 1]
            xticks=[-60, -30, 0, 30, 60]
            
            plot_keywords={}
            plot_keywords.update({'maxv':maxv})
            plot_keywords.update({'minv':minv})
            plot_keywords.update({'dv':dv})
            plot_keywords.update({'title':stitle})
            plot_keywords.update({'yticks':yticks})
            plot_keywords.update({'xticks':xticks})
            
            
            
            while (pos_end<0):
                flcur_yyyy=flcur_yyyy+1
                
                try:
                    pos_end=data_flnm.index(str(flcur_yyyy))
                
                except  ValueError:
                    pos_end=-1
                    
            # pos_end=data_flnm.index("2006")
            short_flnm=data_flnm[0:pos_end]
            print 'short_flnm', short_flnm
            
            file_list=os_cmd.listdir(data_dir)
            choose_fl_list=list()
            
            category_in=bpdata.category
            tracer_in=bpdata.ntracer
            tau0_in=None
            
            for data_fl in file_list:
               if (short_flnm in data_fl):
                   choose_fl_list.append(data_fl)

            
            print 'number of files', len(choose_fl_list)
            choose_fl_list=array(choose_fl_list)
            choose_fl_list=sort(choose_fl_list)
            
            all_val=list()
            first_val=array(vals)
            self.val_name_list=choose_fl_list
                    
            
        
        # pres_lvl=arange(-3, 1.1, 1.0/12.0)
        # pres_lvl=10**(-pres_lvl)
        

            
            for data_fl in choose_fl_list[0:]:
                full_data_fl=self.dirname+"/"+data_fl
                print full_data_fl
                
                category_out,tracer_out,unit_out,\
                    tau0_out,out_array= \
                    fgrd.get_model_value(full_data_fl, \
                                             category=category_in, tracer=tracer_in, tau0=tau0_in)
                
                
                
                vals=fgrd.get_model_zonal_mean(out_array, pressure, pres_lvl)
                
                vals=squeeze(vals)
                
                if (maxv<=minv):
                    maxv=max(vals.flat)
                    maxv=factor*maxv
                    vals=where(vals<-900.0, maxv+900.0,factor*vals)
                    minv=min(vals.flat)
                    vals=where(vals>maxv, minv,vals)
                else:
                    vals=where(vals<-900.0, vals,factor*vals)
                    
                    
                all_val.append(vals)
                
                

            self.val_list=all_val
            
            dlg = wm_mean_plot.CanvasFrame(self, -1, "Setting Plot Parameters",\
                                               first_val, rlat=rlat, rpres=pres_lvl,use_pcolor=0, \
                                               size=(600, 200),\
                                               style=wx.DEFAULT_DIALOG_STYLE,  \
                                               val_list=self.val_list, val_name_list=self.val_name_list,\
                                               plot_keywords=plot_keywords) 
            
            print ' I have reached here'
            # tx=arange(0.0, 2*pi, pi/300.0)
            icount=0
            
            
        
            
    def OnAnimateTotalColumn(self, event):

        
        import time
        import wx


        print '======> OnAnimateTotalColumn'
        
        if (self.currentItem>=0):
            bpdata=self.bpdata_list[self.currentItem]
            rlon=bpdata.grid.get_lon()
            rlat=bpdata.grid.get_lat()
            print 'rlon 0:-1', rlon[0], rlon[-1]

            print 'rlat 0:-1', rlat[0], rlat[-1]
            
            
            nlon=size(rlon)
            nlat=size(rlat)
            
            lfig=figure(self.ifig)
            
            self.ifig=self.ifig+1
            # subplot(2,1,1)
            
            out_array=bpdata.data[:,:,:]
            pressure=self.cal_cur_pressure(bpdata)
            
            vals=fgrd.get_model_colum(out_array[:,:,self.KZ1:self.KZ2], \
                                          pressure[:,:,self.KZ1:self.KZ2])
                
            
            maxv=self.Vmax
            minv=self.Vmin
            unit=bpdata.unit
            
            if (len(self.Unit)>0):
                unit=self.Unit
                
            factor=self.Factor
                
            unit=unit.strip()
            if (len(unit)==0):
                unit='v/v (?)'
            
            
            
            if ((factor<=1) & ('v/v' in unit)):
            
                if (max(vals.flat)<1000.e-9):
                    factor=1.0e9
                    unit='ppb'
                elif (max(vals.flat)<1000.e-6):
                    factor=1.0e6
                    unit='ppm'
            
            if (maxv<=minv):
                maxv=max(vals.flat)
                maxv=factor*maxv
                vals=where(vals<-900.0, maxv+900.0,factor*vals)
                minv=min(vals.flat)
                vals=where(vals>maxv, minv,vals)
            else:
                vals=where(vals<-900.0, vals,factor*vals)
        
            dv=(maxv-minv)/10.0

            # print 'maxv---minv',  maxv, minv
            
        
            stitle=r"ID=%2.2d L=%2.2d-" % (bpdata.ntracer, self.KZ1)
            
        
     #       stitle=r'L=%2.2d ' % self.KZ1
            
            
            if ('name' in bpdata.attr):
                add_str=bpdata.attr['name']
            else:
                add_str=bpdata.category

            add_str=add_str.strip()
            stitle=stitle+' '+add_str
            stitle=stitle+' ('+unit.strip()+')'
            
        
            if ('tau0' in bpdata.attr):
                tau0=bpdata.attr['tau0']
                tau0=3600.*tau0 # convert to seconds
                utc=tm.tai85_to_utc(tau0)
                utc=utc.replace('-', '')
                stitle=stitle+' '+utc
            
             
            # longitude range
            minlon=rlon[self.IX1]
            maxlon=rlon[self.IX2-1]
            if (maxlon>170.0):
                maxlon=180.0
        
            # latitude range
        
            minlat=rlat[self.JY1]
            maxlat=rlat[self.JY2-1]
            cbar_vert=0
            cmap=cm.jet
            plot_keywords={}
            plot_keywords.update({'maxv':maxv})
            plot_keywords.update({'minv':minv})
            plot_keywords.update({'dv':dv})
            plot_keywords.update({'minlon':minlon})
            plot_keywords.update({'maxlon':maxlon})
            plot_keywords.update({'cmap':cmap})
            plot_keywords.update({'title':stitle})
            plot_keywords.update({'cbar_vert':cbar_vert})
            
                                 
            

            #
            data_flnm=self.flnm.strip()
            last_path=-1
            ch_cnt=0
            for ich in data_flnm:
                if (ich=='/'):
                    last_path=ch_cnt
                ch_cnt=ch_cnt+1
            
            
            if (last_path<0):
                data_dir=self.dirname.strip()
                if (len(data_dir)==0):
                    data_dir="./"
            else:
                data_dir=data_flnm[0:last_path]
                data_flnm=data_flnm[last_path+1:]
            
            print 'data_flnm', data_flnm

            pos_end=-1
            flcur_yyyy=1999
            
            while (pos_end<0):
                flcur_yyyy=flcur_yyyy+1
                
                try:
                    pos_end=data_flnm.index(str(flcur_yyyy))
                
                except  ValueError:
                    pos_end=-1
                    
            # pos_end=data_flnm.index("2006")
            short_flnm=data_flnm[0:pos_end]
            print 'short_flnm', short_flnm
            
            file_list=os_cmd.listdir(data_dir)
            choose_fl_list=list()
            
            category_in=bpdata.category
            tracer_in=bpdata.ntracer
            tau0_in=None
            
            for data_fl in file_list:
               if (short_flnm in data_fl):
                   choose_fl_list.append(data_fl)

            
            print 'number of files', len(choose_fl_list)
            choose_fl_list=array(choose_fl_list)
            choose_fl_list=sort(choose_fl_list)
            
            all_val=list()
            first_val=array(vals)
            self.val_name_list=choose_fl_list
                    
            
        
        # pres_lvl=arange(-3, 1.1, 1.0/12.0)
        # pres_lvl=10**(-pres_lvl)
        

            
            for data_fl in choose_fl_list[0:]:
                full_data_fl=self.dirname+"/"+data_fl
                print full_data_fl
                
                category_out,tracer_out,unit_out,\
                    tau0_out,out_array= \
                    fgrd.get_model_value(full_data_fl, \
                                             category=category_in, tracer=tracer_in, tau0=tau0_in)
                
                
                vals=fgrd.get_model_colum(out_array[:,:,self.KZ1:self.KZ2], \
                                              pressure[:,:,self.KZ1:self.KZ2])
                
                vals=squeeze(vals)
                
                if (maxv<=minv):
                    maxv=max(vals.flat)
                    maxv=factor*maxv
                    vals=where(vals<-900.0, maxv+900.0,factor*vals)
                    minv=min(vals.flat)
                    vals=where(vals>maxv, minv,vals)
                else:
                    vals=where(vals<-900.0, vals,factor*vals)
                
                    
                all_val.append(vals)
                
                # dlg.plot_map(vals, rlon=rlon, rlat=rlat,use_pcolor=1,
                #             keywords=plot_keywords)
                # dlg.cs0.set_array(vals)
                # dlg.figure.canvas.draw()
                

                # dlg.Show()
                # time.sleep(10)
                

            self.val_list=all_val
            
            dlg = wmplot.CanvasFrame(self, -1, "Setting Plot Parameters",\
                                     first_val, rlon, rlat,use_pcolor=1, \
                                     size=(600, 200),\
                                     style=wx.DEFAULT_DIALOG_STYLE,  \
                                     val_list=self.val_list, val_name_list=self.val_name_list,\
                                     plot_keywords=plot_keywords) 
            
            print ' I have reached here'
            # tx=arange(0.0, 2*pi, pi/300.0)
            icount=0
        

            
        
    def OnItemSelected(self, event):
        ##print event.GetItem().GetTextColour()
        
        self.currentItem = event.m_itemIndex
        cur_data=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(cur_data.data)
        
        self.text_x.Enable(True)
        self.text_y.Enable(True)
        self.text_z.Enable(True)
        
        self.viewmenu.Enable(ID_VIEW_COL,True)
        self.viewmenu.Enable(ID_VIEW_ZM,True)
        self.viewmenu.Enable(ID_VIEW_MAP,True)
        
        self.animatemenu.Enable(ID_ANIMATE_COL,True)
        self.animatemenu.Enable(ID_ANIMATE_ZM,True)
        self.animatemenu.Enable(ID_ANIMATE_MAP,True)
        
        
        ix, iy, iz=0,0,0

        self.ix, self.iy, self.iz=ix,iy,iz

        self.IX2, self.JY2, self.KZ2=nx,ny,nz
        self.IX1, self.JY1, self.KZ1=ix,iy,iz
        
        
        
        self.text_x.SetValue(str(ix))
        self.text_y.SetValue(str(iy))
        self.text_z.SetValue(str(iz))
        
        val=cur_data.data[ix, iy, iz]
        self.text_v.SetValue(str(val))
        cur_d=cur_data
        
        
        event.Skip()

    def OnItemDeselected(self, evt):
        self.currentItem=-1
        self.text_x.Enable(False)
        self.text_y.Enable(False)
        self.text_z.Enable(False)
        cur_d=None
        
        
    def OnDoubleClick(self, event):
        if (self.currentItem>=0):
            bpdata=self.bpdata_list[self.currentItem]
            figure(self.ifig)
            self.ifig=self.ifig+1
            # subplot(2,1,1)
            bpdata.display(0, show_map=1)
            
            # print 'I am here'
    
    def EvtTextEnter_x(self, event):
#        print 'Here is me'
        
        bpdata=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(bpdata.data)
        ix=self.text_x.GetValue()
#        print ix
#        print nx
        
        IsValid=False
        try:
            ix=int(ix)
            if (ix<nx):
                IsValid=True
                 
        except ValueError:
            pass
        
        if (not IsValid):

            self.err_on=True
            dlg = wx.MessageDialog(self, 'Invalid X Value', 'Error',
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.text_x.SetFocus()
            # self.err_on=False
            
            # return True
        
        else:
            self.ix=ix
            val=bpdata.data[self.ix, self.iy, self.iz]
            self.text_v.SetValue(str(val))
        
        event.Skip()

    def EvtTextKillFocus_x(self, event):
        if (self.err_on):
            event.Skip()
            return
        
        bpdata=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(bpdata.data)
        ix=self.text_x.GetValue()
        IsValid=False
        try:
            ix=int(ix)
            if (ix<nx):
                IsValid=True
            
        except ValueError:
            pass
        
        if (not IsValid):
            self.err_on=True
            dlg = wx.MessageDialog(self, 'Invalid X Value',\
                                   'Error',\
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.text_x.SetFocus()
            # self.err_on=False
            
         #   return True
        
        else:
            self.ix=ix
            

        # self.text_x.SetValue(str(self.ix))
        
                           
        
        event.Skip()
    
    
    def EvtTextEnter_y(self, event):
        bpdata=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(bpdata.data)
        iy=self.text_y.GetValue()
        IsValid=False
        try:
            iy=int(iy)
            if (iy<ny):
                IsValid=True
                 
        except ValueError:
            pass
        
        if (not IsValid):
            self.err_on=True
            dlg = wx.MessageDialog(self, 'Invalid Y Value', 'Error',                           
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.text_y.SetFocus()
            # self.err_on=False
            # return True
        
        else:
            self.iy=iy
            val=bpdata.data[self.ix, self.iy, self.iz]
            self.text_v.SetValue(str(val))
        
        event.Skip()

    def EvtTextKillFocus_y(self, event):
        if (self.err_on):
            event.Skip()
            return
        
        bpdata=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(bpdata.data)
        iy=self.text_y.GetValue()
        IsValid=False
        try:
            iy=int(iy)
            if (iy<ny):
                IsValid=True
            
        except ValueError:
            pass
        
        if (not IsValid):
            self.err_on=True
            dlg = wx.MessageDialog(self, 'Invalid Y Value',\
                                   'Error',\
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.text_y.SetFocus()
            # self.err_on=False
            
            # return True
        
        else:
            self.iy=iy
            
        
                           
        
        event.Skip()
    
    def EvtTextEnter_z(self, event):
        bpdata=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(bpdata.data)
        iz=self.text_z.GetValue()
        IsValid=False
        try:
            iz=int(iz)
            if (iz<nz):
                IsValid=True
                 
        except ValueError:
            pass
        
        if (not IsValid):
            self.err_on=True
            dlg = wx.MessageDialog(self, 'Invalid Z Value','Error',
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.text_z.SetFocus()
            #    return True
            # self.err_on=False
        else:
            self.iz=iz
            val=bpdata.data[self.ix, self.iy, self.iz]
            print val
            self.text_v.SetValue(str(val))
            
        event.Skip()
        

    def EvtTextKillFocus_z(self, event):

        if (self.err_on):
            event.Skip()
            print 'I am here'
            return True
        
        bpdata=self.bpdata_list[self.currentItem]
        nx, ny, nz=shape(bpdata.data)
        iz=self.text_z.GetValue()
        IsValid=False
        try:
            iz=int(iz)
            if (iz<nz):
                IsValid=True
            
        except ValueError:
            pass
        
        if (not IsValid):
            # self.text_y.SetFocus()
            self.err_on=True
            dlg = wx.MessageDialog(self, 'Invalid Z Value',\
                                   'Error',\
                                   wx.OK | wx.ICON_ERROR)
            dlg.ShowModal()
            dlg.Destroy()
            self.text_z.SetFocus()
            # self.err_on=False
            
        
        else:
            self.iz=iz
            
        # self.text_z.SetValue(str(self.iz))
        
                           
        
        event.Skip()
    
    
    def OnLoad(self, event):
        self.fullname=self.text_file.GetValue()
        self.dirname=self.dirname
        self.flnm=self.fullname
        
        self.currentItem=-1
        
        ftracerinfo=self.tracerinfo
        fdiaginfo=self.diaginfo
        flnm=self.fullname.strip()
            
        print flnm
        print ftracerinfo
        print fdiaginfo
        
        bpch2=bpch2_mod.bpch2_file_rw(flnm, 'r', do_read=1, \
                                      ftracerinfo=ftracerinfo, \
                                      fdiaginfo=fdiaginfo)
        all_list=list()
        # bpch2.print_datainfo()
        tracers=None
        categorys=None
        taus=None
        tranames=None
        if (self.bpdata_list<>None):
            self.infolist.DeleteAllItems()
        bpdata_list, found=bpch2.get_data(tracers=tracers, categorys=categorys, taus=taus, tranames=tranames)
        self.bpdata_list=bpdata_list
        j=0
        print file_idd
        nfile=len(file_idd)
        cur_file_id=file_idd[nfile-1]
        cur_file_id=cur_file_id+1
        file_idd.append(cur_file_id)
        
        sfile_idd=r'file_%2.2d' % (cur_file_id)
        # for item in bpdata_list:
        #    cur_l.append(item)
        cur_l.update({sfile_idd:bpdata_list})
        # self.myshell.Execute("local_cur_l=cur_l")
        # self.myshell.Destroy()
        # locals={'cur_l':cur_l, 'test_d':test_d}
        # self.myshell=pysh.shell.Shell(self.panel_cmd, -1,locals=locals, size=(850, 300))
        # self.myshell=pysh.shell.Shell(self.panel_cmd, -1,size=(850, 300))
        
        self.myshell.Execute("print 'loaded data stored in the dict  cur_l with', file_idd")
        self.myshell.Execute("print cur_l.keys()")
        # self.myshell.Execute("print shape(cur_l[0].data)")
        
        
        #  self.myshell.Execute("print 'selected  data in cur_d'")
        # self.myshell.Execute("print test_d")
        
        # help(self.myshell)
        # self.current_sp=None
        
        if (len(bpdata_list)>0):
            self.convertmenu.Enable(ID_CONVERT_REGRID,True)
        else:
            self.convertmenu.Enable(ID_CONVERT_REGRID,False)
        
        for bpdata in bpdata_list:
            traname, tau0, tau1=bpdata.get_attr(['name', 'tau0', 'tau1'])
            traname=traname.strip()
            # print traname
            
            if (traname=='SP' or traname=='PS-PTOP' or traname=='PS'):
                self.current_sp=array(bpdata.data)
                self.current_sp=squeeze(self.current_sp)
                print 'found surface pressure (traname, id,max)', traname.strip(), bpdata.ntracer, max(bpdata.data.flat)
                
                
                
            if (bpdata.category.strip()=='PS-PTOP' or \
                bpdata.category.strip()=='PS' or bpdata.category.strip()=='PEDGE-$'):
                print 'found surface pressure (category, id, max)', bpdata.category.strip(), bpdata.ntracer, max(bpdata.data.flat)
                self.current_sp=array(bpdata.data)
                self.current_sp=squeeze(self.current_sp)
            
            # utc0=tm.tai85_to_utc(3600.0*tau0)
            # utc1=tm.tai85_to_utc(3600.0*tau1)
            # utc0='<'+utc0+'>'
            # utc1='<'+utc1+'>'
            # print bpdata.ntracer, bpdata.category, traname, bpdata.unit, utc0, utc1, shape(bpdata.data), max(bpdata.data.flat),\
            #      min(bpdata.data.flat)
            dix, diy, diz=shape(bpdata.data)
            gpmaxval=max(bpdata.data.flat)
            gpminval=min(bpdata.data.flat)
            sj=r'%2.2d' % (bpdata.ntracer)
            stau0=r'%10.2f' % (tau0)
            stau1=r'%10.2f' % (tau1)
            six=r'%d' % dix
            siy=r'%d' % diy
            siz=r'%d' % diz
            smax='%7.5e' % (gpmaxval)
            smin='%7.5e' % (gpminval)
            
            self.infolist.InsertStringItem(j, sj)
            self.infolist.SetStringItem(j, 2, traname)
            self.infolist.SetStringItem(j, 1, bpdata.category)
            self.infolist.SetStringItem(j, 3, bpdata.unit)
            self.infolist.SetStringItem(j, 4, stau0)
            self.infolist.SetStringItem(j, 5, stau1)
            self.infolist.SetStringItem(j, 6, six)
            self.infolist.SetStringItem(j, 7, siy)
            self.infolist.SetStringItem(j, 8, siz)
            self.infolist.SetStringItem(j, 9, smax)
            self.infolist.SetStringItem(j, 10, smin)
            
            if (j % 2) == 0:
                self.infolist.SetItemBackgroundColour(j, '#e6f1f5')
                                
            if diz ==1:
                self.infolist.SetItemImage(j, self.idx1)
            else:
                self.infolist.SetItemImage(j, self.sm_dn)
            j=j+1
    
              
        
                
    def OnClick_Browse(self, event):
        wildcard = "bpch file (*.bpch)|*.bpch |data files (*.dat) |*.dat | All files (*.*)|*.*"
        
        dirname=self.dirname.strip()
        if (dirname==""):
            dirname=os.getcwd()
            
        dlg=wx.FileDialog(self, "Choose a bpch file", dirname, "", wildcard=wildcard, \
                          style=wx.FD_OPEN | wx.CHANGE_DIR)
        
        dlg.SetFilterIndex(2)
        
        if (dlg.ShowModal()==wx.ID_OK):
            filename=dlg.GetFilename()
            dirname=dlg.GetDirectory()
            full_name=os.path.join(dirname, filename)
            self.dirname=dirname
            self.text_file.SetValue(full_name)
        
        dlg.Destroy()
        

                

    def OnSet(self, event):
        dlg = MyFileDialog_info(self, -1, "Setting", defDir=self.dirname,\
                                defTracer=self.tracerinfo,\
                                defDiag=self.tracerinfo,\
                                size=(450, 300),\
                                style=wx.DEFAULT_DIALOG_STYLE \
                                )
        
        dlg.CenterOnScreen()
        
        val = dlg.ShowModal()
        
        if val == wx.ID_OK:
            self.tracerinfo=dlg.tracertext.GetValue()
            self.diaginfo=dlg.diagtext.GetValue()
            print self.tracerinfo
            print self.diaginfo
            
            
        dlg.Destroy()

    def OnSelectSP(self, event):
        dlg = MyFileDialog_sp(self, -1, "Select Surface Pressure", defDir=self.dirname,\
                              defSP=self.sp_file,\
                              defCategory=self.sp_category, \
                              defSPid=self.sp_id,\
                              defTau=self.sp_tau,\
                              size=(600, 200),\
                              style=wx.DEFAULT_DIALOG_STYLE \
                              )
        
        dlg.CenterOnScreen()
        
        val = dlg.ShowModal()
        
        if val == wx.ID_OK:
            self.sp_file=dlg.spfiletext.GetValue()
            self.sp_id=dlg.spidtext.GetValue()
            self.sp_tau=dlg.tautext.GetValue()
            self.sp_category=dlg.categorytext.GetValue()
            
            # print self.sp_file
            # print self.sp_id
            # print self.sp_category
            
            
        dlg.Destroy()
    def OnViewOption(self, event):
        
        dlg = MyFileDialog_option(self, -1, "Setting Plot Parameters",
                                  defIX1=self.IX1, \
                                  defIX2=self.IX2,\
                                  defJY1=self.JY1, \
                                  defJY2=self.JY2,\
                                  defKZ1=self.KZ1, \
                                  defKZ2=self.KZ2,\
                                  defVmax=self.Vmax,\
                                  defVmin=self.Vmin,\
                                  defFactor=self.Factor,\
                                  defUnit=self.Unit,\
                                  defFigName=self.save_fig_name,\
                                  defFigTitle=self.fig_title,\
                                  size=(600, 250),\
                                  style=wx.DEFAULT_DIALOG_STYLE \
                                  )
        
        dlg.CenterOnScreen()
        
        val = dlg.ShowModal()
        
        if val == wx.ID_OK:

            # x range

            vals=dlg.ix1text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.IX1=int(vals)
                
            
            
            vals=dlg.ix2text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.IX2=int(vals)
                
            
            # yrange

            vals=dlg.jy1text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.JY1=int(vals)
                
            
            
            vals=dlg.jy2text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.JY2=int(vals)
                
            # z range

            vals=dlg.kz1text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.KZ1=int(vals)
                
            
            
            vals=dlg.kz2text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.KZ2=int(vals)
            
            
            # vmin & vmax

            vals=dlg.vmintext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Vmin=float(vals)
                
            
            
            vals=dlg.vmaxtext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Vmax=float(vals)
            
            
            # factor & unit

            vals=dlg.factortext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Factor=float(vals)
                
            
            
            vals=dlg.unittext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Unit=vals.strip()
            
            
            
            # print self.sp_file
            # print self.sp_id
            # print self.sp_category
            
            # the file name to save figure
            vals=dlg.fignametext.GetValue()
            self.save_fig_name=vals.strip()

            # the figure title to draw
            
            vals=dlg.figtitletext.GetValue()
            self.fig_title=vals.strip()
            
            
        dlg.Destroy()
    
        
    def OnAnimateOption(self, event):
        
        dlg = MyFileDialog_option(self, -1, "Setting Plot Parameters",
                                  defIX1=self.IX1, \
                                  defIX2=self.IX2,\
                                  defJY1=self.JY1, \
                                  defJY2=self.JY2,\
                                  defKZ1=self.KZ1, \
                                  defKZ2=self.KZ2,\
                                  defVmax=self.Vmax,\
                                  defVmin=self.Vmin,\
                                  defFactor=self.Factor,\
                                  defUnit=self.Unit,\
                                  defFigName=self.save_fig_name,\
                                  defFigTitle=self.fig_title,\
                                  size=(600, 250),\
                                  style=wx.DEFAULT_DIALOG_STYLE \
                                  )
        
        dlg.CenterOnScreen()
        
        val = dlg.ShowModal()
        
        if val == wx.ID_OK:

            # x range

            vals=dlg.ix1text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.IX1=int(vals)
                
            
            
            vals=dlg.ix2text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.IX2=int(vals)
                
            
            # yrange

            vals=dlg.jy1text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.JY1=int(vals)
                
            
            
            vals=dlg.jy2text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.JY2=int(vals)
                
            # z range

            vals=dlg.kz1text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.KZ1=int(vals)
                
            
            
            vals=dlg.kz2text.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.KZ2=int(vals)
            
            
            # vmin & vmax

            vals=dlg.vmintext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Vmin=float(vals)
                
            
            
            vals=dlg.vmaxtext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Vmax=float(vals)
            
            
            # factor & unit

            vals=dlg.factortext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Factor=float(vals)
                
            
            
            vals=dlg.unittext.GetValue()
            vals=vals.strip()
            if (len(vals)>0):
                self.Unit=vals.strip()
            
            # the file name to save figure
            vals=dlg.fignametext.GetValue()
            self.save_fig_name=vals.strip()

            # the figure title to draw
            
            vals=dlg.figtitletext.GetValue()
            self.fig_title=vals.strip()
            
                            
            
            # print self.sp_file
            # print self.sp_id
            # print self.sp_category
            
            
        dlg.Destroy()
    
          
    def OnConvertRegrid(self, event):
        
        import write_3d_bpch as w3df
        
        dlg = MyFileDialog_regrid(self, -1, "Regrid fields",\
                                      defDir=self.dirname,\
                                      defFlnm="regrid_test", \
                                      defTracer="1",\
                                      size=(300, 240),\
                                      style=wx.DEFAULT_DIALOG_STYLE \
                                      )
        
        dlg.CenterOnScreen()
        
        val = dlg.ShowModal()
        
        if val == wx.ID_OK:

            # mod res
            outfile=dlg.flnmtext.GetValue()
            outfile=outfile.strip()
            selectline=dlg.tracertext.GetValue()
            selectline=selectline.strip()
            terms=selectline.split(',')
            
            select_tracers=list()
            for item in terms:
                item=item.strip()
                if (len(item)>0):
                    if ('-' in item):
                        it1, it2=item.split('-')
                        it1=int(it1)
                        it2=int(it2)
                        for vit in range(it1, it2+1):
                            select_tracers.append(vit)
                    else:
                        select_tracers.append(int(item))
            

            mod_type=5
            
            if (dlg.mod3.GetValue()):
                mod_type=3
                nz=30 # 30 level  
            if (dlg.mod4.GetValue()):
                mod_type=4
                nz=30 
            if (dlg.mod5.GetValue()):
                mod_type=5
                nz=47 # the same as model level 
                
            if (dlg.res4x5.GetValue()):
                mod_res='4x5'
                
            if (dlg.res2x25.GetValue()):
                mod_res='2x25'
                
            if (dlg.res1x1.GetValue()):
                mod_res='1x1'
            
            if (dlg.res05x06.GetValue()):
                mod_res='0.5x0.666'
            
            new_lat=cmg.get_model_lat(mod_res)
            new_lon=cmg.get_model_lon(mod_res)
            
            print 'new size', size(new_lon), size(new_lat)
            
            if (mod_type==5):
                ext1='geos5'
            else:
                ext1='geos'
            
            fix1=dlg.fix1text.GetValue()

            fix1=fix1.strip()
            if (len(fix1)>0):
                fix1=float(fix1)
            else:
                fix1=-999.0
            
            fix2=dlg.fix2text.GetValue()

            fix2=fix2.strip()
            if (len(fix2)>0):
                fix2=float(fix2)
            else:
                fix2=-999.0
                

            outfile=outfile+"."+ext1+"."+mod_res
            
            print '=====> OnConvertRegrid'
            
            funit=w3df.open_3d_bpch2_file(outfile, title='flux', do_ext=False)
            print 'Write regridded data to:' , outfile 
            print 'model info', fix1, fix2, mod_type, mod_res
            print 'selected tracers', select_tracers
            
            init_ps=False
            
            for bpdata in self.bpdata_list:
                tracerid=bpdata.ntracer
                if (tracerid in select_tracers):
                     rlon=bpdata.grid.get_lon()
                     rlat=bpdata.grid.get_lat()
                     nlon=size(rlon)
                     nlat=size(rlat)
                     traname, tau0, tau1=bpdata.get_attr(['name', 'tau0', 'tau1'])
                     
                     if (not init_ps):
                         # model pressure need to be changed 
                         pressure=self.cal_cur_pressure(bpdata)
                         
                         print 'shape(pressure)', shape(pressure)
                         print 'nlon, nlat', nlon, nlat
                         
                         initi_ps=True
                         
                         ax_lat=gax.gp_axis_cl('lat', rlat)
                         ax_lon=gax.gp_axis_cl('lon', rlon)
                         lonp1, lonp2, lonw=ax_lon.getwgt(new_lon)
                         latp1, latp2, latw=ax_lat.getwgt(new_lat)
                         
                         if (self.current_sp<>None):
                             new_data1=lonw[:,newaxis]*self.current_sp[lonp1, :]+\
                                 (1.0-lonw[:,newaxis])*self.current_sp[lonp2,:]
                             new_ps=latw[newaxis, :]*new_data1[:,latp1]+\
                                 (1.0-latw[newaxis, :])*new_data1[:,latp2]
                             new_ps=squeeze(new_ps)
                         
                             print 'new_ps, shape, max, min', shape(new_ps), max(new_ps.flat), min(new_ps.flat)
                             # we need to used nz as the field level, which is one shorter than the pressure edges
                             new_pres, tmp_ps=fgrd.get_model_pressure(nz, mod_type=mod_type, ps=new_ps, \
                                                                          psfile=None, cater_ps='PS',\
                                                                          tracer_ps=None, tau_ps=None)
                             print 'shape new pressure', shape(new_pres)
                     
                             
                         
                         else:
                             new_pres=None
                     
                     
                     new_data=fgrd.regrid_data(bpdata.data, rlon, rlat, \
                                                   new_lon, new_lat, \
                                                   pressure=pressure, new_pres=new_pres)
                     
                     
                     print 'shape of new data:', shape(new_data)
                     
                     if (bpdata.ntracer==1):
                         if (fix1>-900.0):
                             new_data=new_data-new_data+fix1
                     else:
                         if (fix2>-900.0):
                             new_data=new_data-new_data+fix2
                     print 'write data', shape(new_data)
                     
                     w3df.write_3d_field(funit,new_data, \
                                         new_lon, new_lat, \
                                             tau0, tau1,\
                                             bpdata.ntracer, \
                                             ext1,\
                                             category=bpdata.category,\
                                             unit=bpdata.unit, \
                                             do_debug=False)
            
            w3df.close_3d_bpch2_file(funit)
    
            
            
        dlg.Destroy()

    def cal_cur_pressure(self, bpdata):
        import field_grid as fgrd
        if (self.current_sp==None):
            # read sp from default setting
            cater_sp=self.sp_category
            cater_sp=cater_sp.strip()
            sid_sp=self.sp_id
            sid_sp=sid_sp.strip()
            id_sp=None
            if (len(sid_sp)>0 and (sid_sp<>'*')):
                id_sp=int(sid_sp)

            stau_sp=self.sp_tau
            stau_sp=stau_sp.strip()
            
            tau_sp=None
            
            if (len(stau_sp)>0 and (stau_sp<>'*')):
                tau_sp=float(tau_sp)
            
                
            lx=size(bpdata.data[0,0,:])
            print lx
            mod_type=5

            if ('modelname' in bpdata.attr):
                modelname=bpdata.attr['modelname']
                modelname=modelname.strip()
                print 'model name', modelname
                if ('GEOS5' in modelname):
                    mod_type=5
                elif ('GEOS4' in modelname):
                    mod_type=4
            else:    
                print 'can not determine GEOS version and assume it to be 5'
                mod_type=5
                
                
                # if (lx<30):
                #   mod_type=4
                
                
                
            psfile=self.sp_file
            print '  '
            print 'No pressure is set, and load surface pressure for default file'
            print psfile
            print '  '
            
            pressure, new_ps=fgrd.get_model_pressure(lx, mod_type=mod_type, \
                                                         ps=None, psfile=psfile, \
                                                         cater_ps=cater_sp,\
                                                         tracer_ps=id_sp, \
                                                         tau_ps=tau_sp)
            
            if (new_ps==None):
                # no file found 
                dims=shape(bpdata.data)
                new_ps=zeros([dims[0], dims[1]], float)
                new_ps[:,:]=1000.0
                # re call the code 
                pressure, new_ps=fgrd.get_model_pressure(lx, mod_type=mod_type, \
                                                             ps=new_ps)
            else:
                dims=shape(new_ps)
                data_dims=shape(bpdata.data)
                # size mixed up 
                if ((dims[0]<>data_dims[0]) or (dims[1]<>data_dims[1])):
                    print 'size mismatch', shape(new_ps), shape(bpdata.data)
                    
                    dims=shape(bpdata.data)
                    new_ps=zeros([dims[0], dims[1]], float)
                    new_ps[:,:]=1000.0
                    pressure, new_ps=fgrd.get_model_pressure(lx, mod_type=mod_type, \
                                                                 ps=new_ps)
            
            if (new_ps<>None):
                self.current_sp=array(new_ps)
                self.current_sp=squeeze(self.current_sp)
            
            
        else:
            lx=size(bpdata.data[0,0,:])
            mod_type=5
            
            # if (lx<40):
            #     mod_type=4
            
            if ('modelname' in bpdata.attr):
                modelname=bpdata.attr['modelname']
                modelname=modelname.strip()
                print 'model name', modelname
                if ('GEOS5' in modelname):
                    mod_type=5
                elif ('GEOS4' in modelname):
                    mod_type=4
                    
            
            pressure, new_ps=fgrd.get_model_pressure(lx, mod_type=mod_type, \
                                                         ps=self.current_sp)
        return pressure

    
app=wx.PySimpleApp()
frame=MainWindow(None, -1, "CTM Reader")
app.MainLoop()

        
