"""
Test of EOF functions

"""
from netCDF4 import Dataset
import matplotlib.pyplot as plt
from mpl_toolkits.basemap import Basemap
import numpy as npy

import pyeof as peof

ncin = Dataset('/scratch/local/eof/eof2/example_data/sst_ndjfm_anom.nc', 'r')
sst = ncin.variables['sst'][:]
vstt=ncin.variables['sst']
filling_val=getattr(vstt, 'missing_value')
lons = ncin.variables['longitude'][:]
lats = ncin.variables['latitude'][:]
ncin.close()
print npy.shape(lons), npy.shape(lats)
print npy.shape(sst)
print npy.max(sst), npy.min(sst)
coslat = npy.cos(npy.deg2rad(lats))
coslat=npy.sqrt(coslat)
wgts=npy.ones(npy.shape(sst), float)
wgts[:,:,:]= coslat[npy.newaxis, :, npy.newaxis]


cl_eof = peof.eof_cl(sst, wgt=wgts, filling_val=filling_val)


cl_eof.show_pcs([0,1])
fc=cl_eof.get_variance_fraction(2)

cl_eof.show_eofs([0,1])
cl_eof.show_eof_map(0, lons, lats, maxlon=260, minlon=120, maxlat=60, minlat=-20, maxv=0.2, minv=-0.1, dv=1.0/100.0, cmap=plt.cm.jet)


field=sst[0:40, :, :]
proj_pcs=cl_eof.project_field(field, neofs=4, wgt=None, remove_mean=True, filling_val=None)
print npy.shape(proj_pcs)
plt.plot(proj_pcs[:,0])
plt.show()
